// TechProcessDlg.cpp : implementation file
//

#include "stdafx.h"
#include "TechProcessDlg.h"
#include <math.h>
#include "DisAsmStatusDlg.h"
#include "aplguiex.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTechProcessDlg dialog


CTechProcessDlg::CTechProcessDlg(CWnd* pParent /*=NULL*/)
	: CaplResizableDialog(CTechProcessDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTechProcessDlg)
	//}}AFX_DATA_INIT
	m_api=0;
	m_bp=0;
	m_pdf=0;
	m_bp_ref=0;
	m_prd=0;
	m_ReadOnly=false;
	m_bModeCreate=false;
	m_bp_lock=0;
	m_edit_oper=0;
	m_last_oper=-1;
	m_last_oper_col=-1;
	m_mk_ok_char=0;
	m_tp_char=0;
	m_oborud_res_type=0;
	m_oper_bp_type=0;
	m_tp_bp_type=0;
	m_tper_char=0;
	m_perehod_bp_type=0;
	m_oper_next_key=0;
	m_perehod_next_key=0;
	m_edit_perehod=0;
	m_last_perehod=-1;
	m_last_perehod_col=-1;
	m_edit_osn=0;
	m_last_osn=-1;
	m_last_osn_col=-1;
	m_sht_unit=0;
	m_instruk_doc_type=0;
	m_upr_doc_type=0;
	m_razryad_char=0;
	m_ceh_char=0;
	m_uch_char=0;
	m_hardness_char=0;
	m_to_char=0;
	m_tv_char=0;
	m_tpz_char=0;
	m_tsht_char=0;
	m_soj_char=0;
	m_rm_char=0;
	m_last_oper_id="";
	m_cur_org_id="";
	m_poz_instr_char=0;
	m_b_select_from_classifier=false;
	m_ob_classif=0;
	m_osn_classif=0;
	m_diametr_char=0;
	m_dlina_char=0;
	m_glubina_char=0;
	m_prohodu_char=0;
	m_podacha_char=0;
	m_shpindel_char=0;
	m_skorost_char=0;
	m_obiem_char=0;	
}


void CTechProcessDlg::DoDataExchange(CDataExchange* pDX)
{
	CaplResizableDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTechProcessDlg)
	DDX_Control(pDX, IDC_USE_CLASSIFIER, m_use_classifier_ctrl);
	DDX_Control(pDX, IDC_RENUMBER, m_renumber_btn);
	DDX_Control(pDX, IDC_MATERIAL, m_material_ctrl);
	DDX_Control(pDX, IDC_ID, m_id_ctrl);
	DDX_Control(pDX, IDC_OSNASTKA, m_osnastka_ctrl);
	DDX_Control(pDX, IDC_DELETE_OSN, m_delete_osn_btn);
	DDX_Control(pDX, IDC_ADD_OSN, m_add_osn_btn);
	DDX_Control(pDX, IDC_PEREHODS, m_perehod_ctrl);
	DDX_Control(pDX, IDC_EL_PER_TOP, m_el_per_top_btn);
	DDX_Control(pDX, IDC_EL_PER_BOTTOM, m_el_per_bottom_btn);
	DDX_Control(pDX, IDC_DELETE_PEREHOD, m_delete_perehod_btn);
	DDX_Control(pDX, IDC_ADD_PEREHOD, m_add_perehod_btn);
	DDX_Control(pDX, IDS_OPERATIONS, m_operation_ctrl);
	DDX_Control(pDX, IDC_UNDO_CHECK_OUT, m_undo_check_out_btn);
	DDX_Control(pDX, IDC_PRD_NAME, m_prd_name_ctrl);
	DDX_Control(pDX, IDC_PRD_ID, m_prd_id_ctrl);
	DDX_Control(pDX, IDC_PDF_ID, m_pdf_id_ctrl);
	DDX_Control(pDX, IDC_EL_TOP, m_el_top_btn);
	DDX_Control(pDX, IDC_EL_BOTTOM, m_el_bottom_btn);
	DDX_Control(pDX, IDC_DELETE_OPER, m_delete_oper_btn);
	DDX_Control(pDX, IDC_CHECK_OUT, m_check_out_btn);
	DDX_Control(pDX, IDC_CHECK_IN, m_check_in_btn);
	DDX_Control(pDX, IDC_ADD_OPER, m_add_oper_btn);
	DDX_Control(pDX, IDOK, m_ok_btn);
	DDX_Control(pDX, IDCANCEL, m_cancel_btn);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CTechProcessDlg, CaplResizableDialog)
	//{{AFX_MSG_MAP(CTechProcessDlg)
	ON_WM_SIZE()
	ON_BN_CLICKED(IDC_CHECK_OUT, OnCheckOut)
	ON_BN_CLICKED(IDC_UNDO_CHECK_OUT, OnUndoCheckOut)
	ON_BN_CLICKED(IDC_EL_TOP, OnElTop)
	ON_BN_CLICKED(IDC_EL_BOTTOM, OnElBottom)
	ON_BN_CLICKED(IDC_DELETE_OPER, OnDeleteOper)
	ON_NOTIFY(NM_DBLCLK, IDS_OPERATIONS, OnDblclkParams)
	ON_NOTIFY(NM_CLICK, IDS_OPERATIONS, OnClickParams)
	ON_WM_LBUTTONDOWN()
	ON_NOTIFY(LVN_ITEMCHANGED, IDS_OPERATIONS, OnItemchangedOperations)
	ON_NOTIFY(NM_DBLCLK, IDC_PEREHODS, OnDblclkPerehods)
	ON_NOTIFY(NM_CLICK, IDC_PEREHODS, OnClickPerehods)
	ON_BN_CLICKED(IDC_DELETE_PEREHOD, OnDeletePerehod)
	ON_BN_CLICKED(IDC_EL_PER_TOP, OnElPerTop)
	ON_BN_CLICKED(IDC_EL_PER_BOTTOM, OnElPerBottom)
	ON_NOTIFY(LVN_ITEMCHANGED, IDC_PEREHODS, OnItemchangedPerehods)
	ON_BN_CLICKED(IDC_DELETE_OSN, OnDeleteOsn)
	ON_NOTIFY(NM_DBLCLK, IDC_OSNASTKA, OnDblclkOsnastka)
	ON_NOTIFY(NM_CLICK, IDC_OSNASTKA, OnClickOsnastka)
	ON_BN_CLICKED(IDC_RENUMBER, OnRenumber)
	ON_BN_CLICKED(IDC_USE_CLASSIFIER, OnUseClassifier)
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_ADD_OSN, OnAddOsn)
	ON_BN_CLICKED(IDC_CHECK_IN, OnCheckIn)
	ON_BN_CLICKED(IDC_ADD_OPER, OnAddOper)
	ON_BN_CLICKED(IDC_ADD_PEREHOD, OnAddPerehod)
	//}}AFX_MSG_MAP
	ON_NOTIFY(HDN_BEGINTRACK, 0, &CTechProcessDlg::OnHdnBegintrackOperations)
	ON_NOTIFY(LVN_COLUMNCLICK, IDS_OPERATIONS, &CTechProcessDlg::OnLvnColumnclickOperations)
	ON_NOTIFY(NM_SETFOCUS, IDS_OPERATIONS, &CTechProcessDlg::OnNMSetfocusOperations)
	ON_NOTIFY(NM_SETFOCUS, IDC_PEREHODS, &CTechProcessDlg::OnNMSetfocusPerehods)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTechProcessDlg message handlers

BOOL CTechProcessDlg::OnInitDialog() 
{
	CaplResizableDialog::OnInitDialog();

	int v=AfxGetApp()->GetProfileInt(" "," ",0);
	if(0!=v) m_b_select_from_classifier=true;
	m_use_classifier_ctrl.SetCheck(v);

	if(m_b_select_from_classifier)	
	{
		m_ob_classif=m_api->m_classifier_mgr.GetClassifierSystemById("",true);
		if(!m_ob_classif)
		{
			AfxMessageBox("  '' ( )  !");
		}
		m_osn_classif=m_api->m_classifier_mgr.GetClassifierSystemById("",true);
		if(!m_osn_classif)
		{
			AfxMessageBox("  '' ( )  !");
		}
	}

	ListView_SetExtendedListViewStyle(m_operation_ctrl.m_hWnd,
		ListView_GetExtendedListViewStyle(m_operation_ctrl.m_hWnd)
			|LVS_EX_UNDERLINECOLD |LVS_EX_FULLROWSELECT|LVS_EX_GRIDLINES);	
	
	ListView_SetExtendedListViewStyle(m_perehod_ctrl.m_hWnd,
		ListView_GetExtendedListViewStyle(m_perehod_ctrl.m_hWnd)
			|LVS_EX_UNDERLINECOLD |LVS_EX_FULLROWSELECT|LVS_EX_GRIDLINES);	

	ListView_SetExtendedListViewStyle(m_osnastka_ctrl.m_hWnd,
		ListView_GetExtendedListViewStyle(m_osnastka_ctrl.m_hWnd)
			|LVS_EX_UNDERLINECOLD |LVS_EX_FULLROWSELECT|LVS_EX_GRIDLINES);	
	
	AddAnchor(IDC_PRD_NAME,TOP_LEFT, TOP_RIGHT);
	AddAnchor(IDC_MATERIAL,TOP_LEFT, TOP_RIGHT);
	AddAnchor(IDC_ID,TOP_LEFT, TOP_RIGHT);

	AddAnchor(IDC_OPER_TEXT,TOP_LEFT,TOP_RIGHT);
	AddAnchor(IDC_RENUMBER,TOP_RIGHT);
	AddAnchor(IDC_ADD_OPER,TOP_RIGHT);
	AddAnchor(IDC_DELETE_OPER,TOP_RIGHT);
	AddAnchor(IDC_EL_TOP, MIDDLE_LEFT);
	AddAnchor(IDC_EL_BOTTOM, MIDDLE_LEFT);
	AddAnchor(IDS_OPERATIONS,TOP_LEFT, MIDDLE_RIGHT);

	AddAnchor(IDC_PEREHOD_TEXT,MIDDLE_LEFT,MIDDLE_RIGHT);
	AddAnchor(IDC_ADD_PEREHOD,MIDDLE_RIGHT);
	AddAnchor(IDC_DELETE_PEREHOD,MIDDLE_RIGHT);
	AddAnchor(IDC_EL_PER_TOP, MIDDLE_LEFT);
	AddAnchor(IDC_EL_PER_BOTTOM, MIDDLE_LEFT);
	AddAnchor(IDC_PEREHODS,MIDDLE_LEFT, BOTTOM_RIGHT);	

	AddAnchor(IDC_OSNASTKA_TEXT,BOTTOM_LEFT, BOTTOM_RIGHT);
	AddAnchor(IDC_ADD_OSN, BOTTOM_RIGHT);
	AddAnchor(IDC_DELETE_OSN, BOTTOM_RIGHT);
	AddAnchor(IDC_OSNASTKA, BOTTOM_LEFT, BOTTOM_RIGHT);

	RECT r1,r2;
	m_check_out_btn.GetWindowRect(&r1);
	m_check_in_btn.GetWindowRect(&r2);
	ScreenToClient(&r1);
	m_check_in_btn.MoveWindow(&r1);
	ScreenToClient(&r2);
	m_undo_check_out_btn.MoveWindow(&r2);

	AddAnchor(IDOK,BOTTOM_RIGHT);
	AddAnchor(IDCANCEL,BOTTOM_RIGHT);
	AddAnchor(IDC_USE_CLASSIFIER,BOTTOM_RIGHT);
	AddAnchor(IDC_CHECK_OUT,BOTTOM_LEFT);
	AddAnchor(IDC_CHECK_IN,BOTTOM_LEFT);
	AddAnchor(IDC_UNDO_CHECK_OUT,BOTTOM_LEFT);
		
	m_check_out_btn.SetFlat(false);
	m_check_in_btn.SetFlat(false);
	m_undo_check_out_btn.SetFlat(false);
	int color_mode=0;
	if(aplGetBitPerPixel(this)>8) color_mode=1;
	m_check_out_btn.SetIcon(GetAplCheckIco(APL_ICON_CHECKOUT,color_mode)); 
	m_check_in_btn.SetIcon(GetAplCheckIco(APL_ICON_CHECKIN,color_mode)); 
	m_undo_check_out_btn.SetIcon(GetAplCheckIco(APL_ICON_UNDOCHECKOUT,color_mode)); 
	
	m_check_out_btn.SetTooltipText("  ");
	m_check_in_btn.SetTooltipText(" ");
	m_undo_check_out_btn.SetTooltipText(" "); 

	m_el_top_btn.SetIcon(GetAplTableIco(APL_TABLE_TOP));
	m_el_top_btn.SetFlat(false);
	m_el_bottom_btn.SetIcon(GetAplTableIco(APL_TABLE_BOTTOM));
	m_el_bottom_btn.SetFlat(false);
	m_add_oper_btn.SetIcon(GetAplStdIco16(APLSTDICO_PLUS));
	m_add_oper_btn.SetTooltipText(" ");
	m_add_oper_btn.SetFlat(FALSE);
	m_delete_oper_btn.SetIcon(GetAplTableIco(APL_TABLE_DEL));
	m_delete_oper_btn.SetTooltipText(" ");
	m_delete_oper_btn.SetFlat(FALSE);

	m_el_per_top_btn.SetIcon(GetAplTableIco(APL_TABLE_TOP));
	m_el_per_top_btn.SetFlat(false);
	m_el_per_bottom_btn.SetIcon(GetAplTableIco(APL_TABLE_BOTTOM));
	m_el_per_bottom_btn.SetFlat(false);
	m_add_perehod_btn.SetIcon(GetAplStdIco16(APLSTDICO_PLUS));
	m_add_perehod_btn.SetTooltipText(" ");
	m_add_perehod_btn.SetFlat(FALSE);
	m_delete_perehod_btn.SetIcon(GetAplTableIco(APL_TABLE_DEL));
	m_delete_perehod_btn.SetTooltipText(" ");
	m_delete_perehod_btn.SetFlat(FALSE);

	m_add_osn_btn.SetIcon(GetAplStdIco16(APLSTDICO_PLUS));
	m_add_osn_btn.SetTooltipText(" ");
	m_add_osn_btn.SetFlat(FALSE);
	m_delete_osn_btn.SetIcon(GetAplTableIco(APL_TABLE_DEL));
	m_delete_osn_btn.SetTooltipText(" ");
	m_delete_osn_btn.SetFlat(FALSE);

	m_cancel_btn.SetIcon(GetAplStdIco16(APLSTDICO_CANCEL));
	m_cancel_btn.SetFlat(FALSE);
	m_ok_btn.SetIcon(GetAplStdIco16(APLSTDICO_OK));
	m_ok_btn.SetFlat(FALSE);
	
	RECT rect;
	DWORD dwStyle;

	dwStyle = WS_CHILD|WS_BORDER|ES_LEFT|ES_AUTOHSCROLL ;
	m_edit.Create(dwStyle,rect,&m_perehod_ctrl,IDC_ST_EDIT);
	m_edit.SetFont(m_perehod_ctrl.GetFont());

	m_edit_id.Create(dwStyle,rect,&m_operation_ctrl,IDC_ST_EDIT0);
	m_edit_id.SetFont(m_operation_ctrl.GetFont());

	m_edit_res.Create(dwStyle,rect,&m_osnastka_ctrl,IDC_ST_EDIT1);
	m_edit_res.SetFont(m_osnastka_ctrl.GetFont());

	m_edit_char.Create(dwStyle,rect,&m_operation_ctrl,IDC_ST_EDIT2);
	m_edit_char.SetFont(m_operation_ctrl.GetFont());

	dwStyle = WS_CHILD|CBS_DROPDOWNLIST|CBS_SORT|WS_VSCROLL;
	m_combo.Create(dwStyle,rect,&m_operation_ctrl,IDC_ST_CCOMBO2);
	m_combo.SetFont(m_operation_ctrl.GetFont());
	m_combo_char.Create(dwStyle,rect,&m_operation_ctrl,IDC_ST_CCOMBO3);
	m_combo_char.SetFont(m_operation_ctrl.GetFont());
	m_combo_razryad.Create(dwStyle,rect,&m_operation_ctrl,IDC_ST_CCOMBO6);
	m_combo_razryad.SetFont(m_operation_ctrl.GetFont());
	m_combo_res.Create(dwStyle,rect,&m_osnastka_ctrl,IDC_ST_CCOMBO4);
	m_combo_res.SetFont(m_osnastka_ctrl.GetFont());
	m_combo_unit.Create(dwStyle,rect,&m_osnastka_ctrl,IDC_ST_CCOMBO5);
	m_combo_unit.SetFont(m_osnastka_ctrl.GetFont());
	
	long trd=aplStartWaitDlg("  ");
	// 
	CString scht;
	aplExtent ext;
	CString buf,buf1;
	m_api->m_data.GetEntityExtentBN("step_unit",ext);
	int new_elem;
	int i;
	for(i=0;i<ext.Size;i++)
	{
		m_api->m_charact_mgr.GetUnitName(ext[i],buf);
		new_elem=m_combo_unit.AddString(buf);
		m_combo_unit.SetItemData(new_elem,(long)ext[i]);
		buf1=buf;
		buf1.MakeLower();
		if(buf1.GetLength()>=2)	{if((buf1[0]=='')&&(buf1[1]=='')){m_sht_unit=ext[i];scht=buf;}}

	}
	new_elem=m_combo_unit.AddString("");
	m_combo_unit.SetItemData(new_elem,0);
	if(scht!="") m_combo_unit.SelectString(-1,scht);

	m_mk_ok_char=m_api->m_charact_mgr.GetCharacteristicById("_");
	if(!m_mk_ok_char) AfxMessageBox(" '_'  !");
	m_tp_char=m_api->m_charact_mgr.GetCharacteristicById("");
	if(!m_tp_char) AfxMessageBox(" ''  !");
	m_tper_char=m_api->m_charact_mgr.GetCharacteristicById("t");
	if(!m_tper_char) AfxMessageBox(" 't'  !");
	m_razryad_char=m_api->m_charact_mgr.GetCharacteristicById("");
	if(!m_razryad_char) AfxMessageBox(" '' ( )  !");
	m_ceh_char=m_api->m_charact_mgr.GetCharacteristicById("");
	if(!m_ceh_char) AfxMessageBox(" '' (  )  !");
	m_uch_char=m_api->m_charact_mgr.GetCharacteristicById("");
	if(!m_uch_char) AfxMessageBox(" '' (  )  !");
	m_hardness_char=m_api->m_charact_mgr.GetCharacteristicById("");
	if(!m_hardness_char) AfxMessageBox(" ''  !");
	m_to_char=m_api->m_charact_mgr.GetCharacteristicById("");
	if(!m_to_char) AfxMessageBox(" ''  !");
	m_tv_char=m_api->m_charact_mgr.GetCharacteristicById("");
	if(!m_tv_char) AfxMessageBox(" ''  !");
	m_tpz_char=m_api->m_charact_mgr.GetCharacteristicById("");
	if(!m_tpz_char) AfxMessageBox(" ''  !");
	m_tsht_char=m_api->m_charact_mgr.GetCharacteristicById("");
	if(!m_tsht_char) AfxMessageBox(" ''  !");
	m_soj_char=m_api->m_charact_mgr.GetCharacteristicById("");
	if(!m_soj_char) AfxMessageBox(" ''  !");
	m_rm_char=m_api->m_charact_mgr.GetCharacteristicById("");
	if(!m_rm_char) AfxMessageBox(" ''  !");
	
	m_poz_instr_char=m_api->m_charact_mgr.GetCharacteristicById("_");
	if(!m_poz_instr_char) AfxMessageBox(" '_' ( )  !");

	m_diametr_char=m_api->m_charact_mgr.GetCharacteristicById("D  B");
	if(!m_diametr_char) AfxMessageBox(" 'D  B'  !");
	m_dlina_char=m_api->m_charact_mgr.GetCharacteristicById("l");
	if(!m_dlina_char) AfxMessageBox(" 'l'  !");
	m_glubina_char=m_api->m_charact_mgr.GetCharacteristicById("t");
	if(!m_glubina_char) AfxMessageBox(" 't'  !");
	m_prohodu_char=m_api->m_charact_mgr.GetCharacteristicById("i");
	if(!m_prohodu_char) AfxMessageBox(" 'i'  !");
	m_podacha_char=m_api->m_charact_mgr.GetCharacteristicById("s");
	if(!m_podacha_char) AfxMessageBox(" 's'  !");
	m_shpindel_char=m_api->m_charact_mgr.GetCharacteristicById("n");
	if(!m_shpindel_char) AfxMessageBox(" 'n'  !");
	m_skorost_char=m_api->m_charact_mgr.GetCharacteristicById("v");
	if(!m_skorost_char) AfxMessageBox(" 'v'  !");
	m_obiem_char=m_api->m_charact_mgr.GetCharacteristicById("  ");
	if(!m_obiem_char) AfxMessageBox(" '  '  !");
	m_pi_char=m_api->m_charact_mgr.GetCharacteristicById("");
	if(!m_pi_char) AfxMessageBox(" ''  !");
	m_totv_char=m_api->m_charact_mgr.GetCharacteristicById("/");
	if(!m_totv_char) AfxMessageBox(" '/'  !");
	
	if(m_razryad_char)
	{
		m_combo_razryad.AddString("");
		CaplInstance *raz_unit=0;
		m_api->m_data.GetAttr(m_razryad_char,m_api->m_charact_mgr.a_apl_charact_unit,raz_unit);
		if(raz_unit)
		{
			CaplAggr aggr;
			m_api->m_data.GetAttrBN(raz_unit,"values",aggr);
			for(int i=0;i<aggr.GetSize();i++)
			{
				if(aggr.GetByIndex(i,buf))
					m_combo_razryad.AddString(buf);
			}
		}
	}

	//   
	aplExtent ext_res;
	int new_type=m_combo_res.AddString("");
	m_combo_res.SetItemData(new_type,0);
	m_api->m_data.GetEntityExtent(m_api->m_bp_mgr.e_bp_res_type,ext_res);
	for(i=0;i<ext_res.Size;i++)
	{
		m_api->m_data.GetAttr(ext_res[i],m_api->m_bp_mgr.a_bp_res_type_name,buf);
		new_type=m_combo_res.AddString(buf);
		m_combo_res.SetItemData(new_type,long(ext_res[i]));
		if(buf=="") m_oborud_res_type=ext_res[i];
	}
	if(!m_oborud_res_type) AfxMessageBox("  ''  !");

	//   
	aplExtent ext_bp_types;
	m_api->m_data.GetEntityExtent(m_api->m_bp_mgr.e_bp_type,ext_bp_types);
	for(i=0;i<ext_bp_types.Size;i++)
	{
		m_api->m_data.GetAttr(ext_bp_types[i],m_api->m_bp_mgr.a_bp_type_name,buf);
		if(buf=="") 
		{
			m_oper_bp_type=ext_bp_types[i];
		}
		else if(buf==" ")
		{
			m_tp_bp_type=ext_bp_types[i];
		}
		else if(buf=="")
		{
			m_perehod_bp_type=ext_bp_types[i];
		}
	}
	if(!m_tp_bp_type) AfxMessageBox("  ' '  !");
	if(!m_oper_bp_type) AfxMessageBox("  ''  !");
	if(!m_perehod_bp_type) AfxMessageBox("  ''  !");
	
	m_instruk_doc_type=m_api->m_doc_mgr.GetDocumentTypeBN("");
	if(!m_instruk_doc_type) AfxMessageBox("  ''  !");
	m_upr_doc_type=m_api->m_doc_mgr.GetDocumentTypeBN(" ");
	if(!m_upr_doc_type) AfxMessageBox("  ' '  !");

	CaplInstance *cur_user= m_api->m_data.GetCurrUser();
	if(cur_user)
	{
		CaplInstance *po= NULL;
		m_api->m_data.GetAttr(cur_user, m_api->m_appr_mgr.a_apl_user_po, po);
		if(po)
		{
			CaplInstance *cur_org;
			m_api->m_data.GetAttr(po, m_api->m_appr_mgr.a_po_the_org, cur_org);
			if(cur_org)
			{
				m_api->m_data.GetAttr(cur_org, m_api->m_appr_mgr.a_org_id,m_cur_org_id);
				m_cur_org_id.MakeUpper();
			}
		}
	}
	
	GetOperNames();
	SetTablesColumns();
	ReadTPInfo();
	LoadDocs();
	UpdateOperationsCtrl();	
	UpdatePerehodsCtrl();
	SetReadOnlyItems();
	CenterWindow();
	
	aplEndWaitDlg(trd);
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CTechProcessDlg::SetTablesColumns()
{
	// 
	m_operation_ctrl.InsertColumn(0,"",LVCFMT_LEFT,25);
	m_operation_ctrl.InsertColumn(1,"",LVCFMT_LEFT,50);
	m_operation_ctrl.InsertColumn(2,"",LVCFMT_LEFT,100);
	m_operation_ctrl.InsertColumn(3,"",LVCFMT_LEFT,100);
	m_operation_ctrl.InsertColumn(4,"/",LVCFMT_LEFT,50);
	m_operation_ctrl.InsertColumn(5,"",LVCFMT_LEFT,50);
	m_operation_ctrl.InsertColumn(6,"",LVCFMT_LEFT,50);
	m_operation_ctrl.InsertColumn(7,"",LVCFMT_LEFT,50);
	m_operation_ctrl.InsertColumn(8,"",LVCFMT_LEFT,50);
	m_operation_ctrl.InsertColumn(9,"",LVCFMT_LEFT,50);
	m_operation_ctrl.InsertColumn(10,"",LVCFMT_LEFT,50);
	m_operation_ctrl.InsertColumn(11,"t ",LVCFMT_LEFT,50);
	m_operation_ctrl.InsertColumn(12,"",LVCFMT_LEFT,50);
	m_operation_ctrl.InsertColumn(13,"",LVCFMT_LEFT,50);
	m_operation_ctrl.InsertColumn(14,"",LVCFMT_LEFT,50);
	m_operation_ctrl.InsertColumn(15,".",LVCFMT_LEFT,50);
	m_operation_ctrl.InsertColumn(16," ",LVCFMT_LEFT,30);
	m_operation_ctrl.InsertColumn(17,"",LVCFMT_LEFT,50);
	m_operation_ctrl.InsertColumn(18,"",LVCFMT_LEFT,50);
	m_operation_ctrl.InsertColumn(19,"",LVCFMT_LEFT,50);

	//
	m_perehod_ctrl.InsertColumn(0,"",LVCFMT_LEFT,25);
	m_perehod_ctrl.InsertColumn(1,"",LVCFMT_LEFT,350);
	m_perehod_ctrl.InsertColumn(2,"t ",LVCFMT_LEFT,50);
	m_perehod_ctrl.InsertColumn(3,"/",LVCFMT_LEFT,70);
	m_perehod_ctrl.InsertColumn(4,"",LVCFMT_LEFT,70);
	m_perehod_ctrl.InsertColumn(5,"",LVCFMT_LEFT,70);
	m_perehod_ctrl.InsertColumn(6,"D  ",LVCFMT_LEFT,70);
	m_perehod_ctrl.InsertColumn(7,"L",LVCFMT_LEFT,70);
	m_perehod_ctrl.InsertColumn(8,"t",LVCFMT_LEFT,70);
	m_perehod_ctrl.InsertColumn(9,"i",LVCFMT_LEFT,70);
	m_perehod_ctrl.InsertColumn(10,"s",LVCFMT_LEFT,70);
	m_perehod_ctrl.InsertColumn(11,"n",LVCFMT_LEFT,70);
	m_perehod_ctrl.InsertColumn(12,"v",LVCFMT_LEFT,70);
	m_perehod_ctrl.InsertColumn(13,"  ",LVCFMT_LEFT,70);
	m_perehod_ctrl.InsertColumn(14," ",LVCFMT_LEFT,210);

	//
	m_osnastka_ctrl.InsertColumn(0,"",LVCFMT_LEFT,25);
	m_osnastka_ctrl.InsertColumn(1,"",LVCFMT_LEFT,200);
	m_osnastka_ctrl.InsertColumn(2,"",LVCFMT_LEFT,300);
	m_osnastka_ctrl.InsertColumn(3,"",LVCFMT_LEFT,60);
	m_osnastka_ctrl.InsertColumn(4,"..",LVCFMT_LEFT,60);
	m_osnastka_ctrl.InsertColumn(5,"_",LVCFMT_LEFT,60);
}

void CTechProcessDlg::LoadDocs()
{
	int i;
	CaplInstance *item=0;
	CaplInstance *type=0;
	CaplInstance *doc=0;
	if(m_instruk_doc_type)
	{
		aplExtent ext_oper;
		for(i=0;i<m_operations.GetSize();i++) 
		{
			if(!m_operations[i].bp) continue;
			if(m_operations[i].bp->GetAccessmode()>aplRO) continue;
			ext_oper.Add(m_operations[i].bp);
		}
		aplExtent ext_oper_docs,ext_oper_docs_rel;
		m_api->m_doc_mgr.FindAssociatedDocuments(ext_oper,ext_oper_docs,ext_oper_docs_rel,0);
	
		for(i=0;i<m_operations.GetSize();i++) 
		{
			if(!m_operations[i].bp) continue;
			if(m_operations[i].bp->GetAccessmode()>aplRO) continue;
			for(int j=0;j<ext_oper_docs_rel.GetSize();j++)
			{
				m_api->m_data.GetAttr(ext_oper_docs_rel[j],m_api->m_doc_mgr.a_apl_doc_ref_item,item);
				if(item==m_operations[i].bp)
				{
					m_api->m_data.GetAttr(ext_oper_docs_rel[j],m_api->m_doc_mgr.a_apl_doc_ref_doc,doc);
					if(doc)
					{
						m_api->m_data.GetAttr(doc,m_api->m_doc_mgr.a_doc_kind,type);
						if(type==m_instruk_doc_type) 
						{
							m_operations[i].instruk=doc;
							m_operations[i].instruk_rel=ext_oper_docs_rel[j];
						}
						else if(type==m_upr_doc_type) 
						{
							m_operations[i].upr_prog=doc;
							m_operations[i].upr_prog_rel=ext_oper_docs_rel[j];
						}
						if(m_operations[i].upr_prog && m_operations[i].instruk) break;
					}
				}
			}
		}
	}
	if(!m_upr_doc_type) return;
	aplExtent ext_perehods;
	for(i=0;i<m_perehods.GetSize();i++) 
	{
		if(!m_perehods[i].perehod) continue;
		if(m_perehods[i].perehod->GetAccessmode()>aplRO) continue;
		ext_perehods.Add(m_perehods[i].perehod);
	}
	aplExtent ext_perehod_docs,ext_perehod_docs_rel;
	m_api->m_doc_mgr.FindAssociatedDocuments(ext_perehods,ext_perehod_docs,ext_perehod_docs_rel,0);
	for(i=0;i<m_perehods.GetSize();i++) 
	{
		if(!m_perehods[i].perehod) continue;
		if(m_perehods[i].perehod->GetAccessmode()>aplRO) continue;
		for(int j=0;j<ext_perehod_docs_rel.GetSize();j++)
		{
			m_api->m_data.GetAttr(ext_perehod_docs_rel[j],m_api->m_doc_mgr.a_apl_doc_ref_item,item);
			if(item==m_perehods[i].perehod)
			{
				m_api->m_data.GetAttr(ext_perehod_docs_rel[j],m_api->m_doc_mgr.a_apl_doc_ref_doc,doc);
				if(doc) 
				{
					m_perehods[i].ac_doc=doc;
					m_perehods[i].ac_doc_rel=ext_perehod_docs_rel[j];
					break;
				}
			}
		}
	}
}

void CTechProcessDlg::ReadTPInfo()
{
	CString buf="";
	//  
	CaplInstance *cur_zagotov=0;
	if(m_bp && !m_bp_ref)
	{
		//     (,       ) 
		CaplLoadData ld(&m_api->m_data,DEF_SOURCE);
		int a=ld.AddQuery('b',m_bp->GetId(),m_api->m_bp_mgr.e_bp_ref,m_api->m_bp_mgr.a_bp_ref_process,true,true);
		    a=ld.AddQuery('d', a, 0, m_api->m_bp_mgr.a_bp_ref_item, true,true);
			  ld.AddQuery('d', a, 0, m_api->m_prd_mgr.a_pdf_prd, true,true);
		ld.AddQuery('d', 0, 0, m_api->m_bp_mgr.a_bp_ref_zagotov, true,true);
		ld.LoadEx();

		aplExtent ext;
		CaplInstance *ref_process=0;
		m_api->m_data.GetEntityExtent(m_api->m_bp_mgr.e_bp_ref,ext);
		for(int i=0;i<ext.GetSize();i++)
		{
			if(!ext[i]) continue;
			if(ext[i]->GetAccessmode()>aplRO) continue;
			m_api->m_data.GetAttr(ext[i],m_api->m_bp_mgr.a_bp_ref_process,ref_process);
			if(ref_process==m_bp)
			{
				m_bp_ref=ext[i];
				break;
			}
		}

	}
	if(m_bp_ref)
	{
		m_api->m_data.GetAttr(m_bp_ref,m_api->m_bp_mgr.a_bp_ref_item,m_pdf);
		m_api->m_data.GetAttr(m_bp_ref,m_api->m_bp_mgr.a_bp_ref_zagotov,cur_zagotov);
	}
	//      ...
	int new_elem=m_material_ctrl.AddString("");
	m_material_ctrl.SetItemData(new_elem,(long)0);
	m_material_ctrl.SetCurSel(new_elem);

	if(m_pdf)
	{
		if(m_pdf->GetAccessmode()<aplNO)
		{
			if(m_api->m_data.IsKindOf(m_pdf,m_api->m_prd_mgr.e_pdf))
			{	
				m_api->m_data.GetAttr(m_pdf,m_api->m_prd_mgr.a_pdf_id,buf);
				m_pdf_id_ctrl.SetWindowText(buf);
				m_api->m_data.GetAttr(m_pdf,m_api->m_prd_mgr.a_pdf_prd,m_prd);
				if(m_prd)
				{
					if(m_prd->GetAccessmode()<aplNO)
					{
						m_api->m_data.GetAttr(m_prd,m_api->m_prd_mgr.a_prd_id,buf);
						m_prd_id_ctrl.SetWindowText(buf);
						m_api->m_data.GetAttr(m_prd,m_api->m_prd_mgr.a_prd_name,buf);
						m_prd_name_ctrl.SetWindowText(buf);
					}
				}
			}
			//   
			
			int i;
			aplExtent ext_rel,ext_pdf;
			m_api->m_prd_mgr.LoadAllZagotov(m_pdf,ext_rel,ext_pdf,true,true);
			CaplInstance *zagotov=0;
			for(i=0;i<ext_rel.GetSize();i++)
			{
				if(!ext_rel[i]) continue;
				if(ext_rel[i]->GetAccessmode()>aplRO) continue;
				m_api->m_data.GetAttr(ext_rel[i],m_api->m_prd_mgr.a_pdr_r_ted,zagotov);
				if(zagotov)
				{
					if(zagotov->GetAccessmode()<aplNO) 
					{
						m_api->GetItemName(zagotov,buf);
						new_elem=m_material_ctrl.AddString(buf);
						m_material_ctrl.SetItemData(new_elem,(long)ext_rel[i]);
					}
				}
			}
			for(i=0;i<m_material_ctrl.GetCount();i++)
			{
				CaplInstance *rel=(CaplInstance *)m_material_ctrl.GetItemData(i);
				if(rel==cur_zagotov)
				{
					m_material_ctrl.SetCurSel(i);
					break;
				}
			}

		}
	}
	// 
	if(m_bp) 
	{
		m_bp_lock=m_api->m_bp_mgr.CheckMyLock(m_bp,false);
		if(m_bp_lock) m_api->m_data.GetAttr(m_bp_lock,m_api->m_bp_mgr.a_bp_ver_id,buf);
		else m_api->m_data.GetAttr(m_bp,m_api->m_bp_mgr.a_bp_id,buf);
		m_id_ctrl.SetWindowText(buf);
		aplExtent ext_sub;
		m_api->m_bp_mgr.GetAllSubBP(m_bp,ext_sub);
		m_api->m_bp_mgr.LoadBPInfo(ext_sub);
		UpdateOperations();		
	}
	
}

void CTechProcessDlg::UpdatePerehodsCtrl()
{
	int num=m_operation_ctrl.GetNextItem(-1,LVNI_SELECTED);
	int sel=m_perehod_ctrl.GetNextItem(-1,LVNI_SELECTED);
	m_osnastka_ctrl.DeleteAllItems();
	m_perehod_ctrl.DeleteAllItems();
	if(num<0) return;
	OperationStruct *sel_oper=(OperationStruct *)m_operation_ctrl.GetItemData(num);
	if(!sel_oper) return;

	CString buf;
	int count=0;
	for(int i=0;i<m_perehods.GetSize();i++) 
	{
		if(m_perehods[i].oper!=sel_oper->key) continue;
		count++;
		buf.Format("%3i",count);
		int k=m_perehod_ctrl.InsertItem(count,buf);

		m_perehod_ctrl.SetItemData(k,(long)&m_perehods[i]);
		m_perehod_ctrl.SetItemText(k,1,m_perehods[i].descr);
		buf="";
		if(m_perehods[i].t_per)
		{
			if(floor(m_perehods[i].t_per)==m_perehods[i].t_per) buf.Format("%d",long(m_perehods[i].t_per));
			else buf.Format("%.2f",m_perehods[i].t_per);
		}
		m_perehod_ctrl.SetItemText(k,2,buf);
		buf="";
		if(m_perehods[i].osn_amount) 
		{
			buf.Format("%d",m_perehods[i].osn_amount);
		}
		m_perehod_ctrl.SetItemText(k,4,buf);

		buf="";
		if(m_perehods[i].diametr) buf.Format("%g",m_perehods[i].diametr);
		m_perehod_ctrl.SetItemText(k, 6, buf);

		buf="";
		if(m_perehods[i].dlina) buf.Format("%g",m_perehods[i].dlina);
		m_perehod_ctrl.SetItemText(k, 7, buf);

		buf="";
		if(m_perehods[i].glubina) buf.Format("%g",m_perehods[i].glubina);
		m_perehod_ctrl.SetItemText(k, 8, buf);

		buf="";
		if(m_perehods[i].prohodu) buf.Format("%g",m_perehods[i].prohodu);
		m_perehod_ctrl.SetItemText(k, 9, buf);

		buf="";
		if(m_perehods[i].podacha) buf.Format("%g",m_perehods[i].podacha);
		m_perehod_ctrl.SetItemText(k, 10, buf);

		buf="";
		if(m_perehods[i].shpindel) buf.Format("%g",m_perehods[i].shpindel);
		m_perehod_ctrl.SetItemText(k, 11, buf);

		buf="";
		if(m_perehods[i].skorost) buf.Format("%g",m_perehods[i].skorost);
		m_perehod_ctrl.SetItemText(k, 12, buf);

		m_perehod_ctrl.SetItemText(k, 13, m_perehods[i].obiem);
		m_perehod_ctrl.SetItemText(k, 5, m_perehods[i].pi);

		buf="";
		if(m_perehods[i].totv) buf.Format("%g",m_perehods[i].totv);
		m_perehod_ctrl.SetItemText(k, 3, buf);

		buf="";
		if(m_perehods[i].ac_doc) m_api->m_data.GetAttr(m_perehods[i].ac_doc,m_api->m_doc_mgr.a_doc_id,buf);
		m_perehod_ctrl.SetItemText(k,43,buf);

	}
	if(m_perehod_ctrl.GetItemCount())
	{
		if(sel<0) sel=0;
		else if(sel>=m_perehod_ctrl.GetItemCount()) sel=m_perehod_ctrl.GetItemCount()-1;
		m_perehod_ctrl.SetItemState(sel,LVIS_SELECTED,-1);
		m_perehod_ctrl.EnsureVisible(sel,false);
	}
}

void CTechProcessDlg::UpdateOsnastkaCtrl()
{
	int num=m_perehod_ctrl.GetNextItem(-1,LVNI_SELECTED);
	int sel=m_osnastka_ctrl.GetNextItem(-1,LVNI_SELECTED);
	m_osnastka_ctrl.DeleteAllItems();
	if(num<0) return;
	PerehodStruct *sel_perehod=(PerehodStruct *)m_perehod_ctrl.GetItemData(num);
	if(!sel_perehod) return;

	CString buf;
	int count=0;
	for(int i=0;i<m_osnastka.GetSize();i++) 
	{
		if(m_osnastka[i].perehod!=sel_perehod->key) continue;
		count++;
		buf.Format("%3i",count);
		int k=m_osnastka_ctrl.InsertItem(count,buf);
		m_osnastka_ctrl.SetItemData(k,(long)&m_osnastka[i]);
		buf="";
		if(m_osnastka[i].res_type) 
			m_api->m_data.GetAttr(m_osnastka[i].res_type,m_api->m_bp_mgr.a_bp_res_type_name,buf);
		m_osnastka_ctrl.SetItemText(k,1,buf);
		buf="";
		if(m_osnastka[i].object) m_api->GetItemName(m_osnastka[i].object,buf);
		m_osnastka_ctrl.SetItemText(k,2,buf);
		buf="";
		if(m_osnastka[i].amount) 
		{
			if(floor(m_osnastka[i].amount)==m_osnastka[i].amount) 
				buf.Format("%d",long(m_osnastka[i].amount));
			else 
				buf.Format("%.2f",m_osnastka[i].amount);
		}
		m_osnastka_ctrl.SetItemText(k,3,buf);
		buf="";
		if(m_osnastka[i].ed_izm) m_api->m_charact_mgr.GetUnitName(m_osnastka[i].ed_izm,buf);
		m_osnastka_ctrl.SetItemText(k,4,buf);
		
		m_osnastka_ctrl.SetItemText(k,5,m_osnastka[i].poz_instr);
	}
	if(m_osnastka_ctrl.GetItemCount())
	{
		if(sel<0) sel=0;
		else if(sel>=m_osnastka_ctrl.GetItemCount()) sel=m_osnastka_ctrl.GetItemCount()-1;
		m_osnastka_ctrl.SetItemState(sel,LVIS_SELECTED,-1);
		m_osnastka_ctrl.EnsureVisible(sel,false);
	}
}

void CTechProcessDlg::UpdateOperationsCtrl()
{
	CString buf;
	int sel=m_operation_ctrl.GetNextItem(-1,LVNI_SELECTED);
	m_operation_ctrl.DeleteAllItems();
	for(int i=0;i<m_operations.GetSize();i++) 
	{
		buf.Format("%3i",i+1);
		int k=m_operation_ctrl.InsertItem(i,buf);
		m_operation_ctrl.SetItemData(k,(long)&m_operations[i]);
		m_operation_ctrl.SetItemText(k,1,m_operations[i].id);
		m_operation_ctrl.SetItemText(k,2,m_operations[i].name);
		buf="";
		if(m_operations[i].oborud) m_api->GetItemName(m_operations[i].oborud,buf);
		m_operation_ctrl.SetItemText(k,3,buf);
		m_operation_ctrl.SetItemText(k,4,m_operations[i].mk_ok);
		m_operation_ctrl.SetItemText(k,5,m_operations[i].tech_passport);
		m_operation_ctrl.SetItemText(k,6,m_operations[i].hardness);

		buf="";
		if(m_operations[i].to) buf.Format("%g",m_operations[i].to);
		m_operation_ctrl.SetItemText(k,7,buf);

		buf="";
		if(m_operations[i].tv) buf.Format("%g",m_operations[i].tv);
		m_operation_ctrl.SetItemText(k,8,buf);

		buf="";
		if(m_operations[i].tpz) buf.Format("%g",m_operations[i].tpz);
		m_operation_ctrl.SetItemText(k,9,buf);

		buf="";
		if(m_operations[i].tsht) buf.Format("%g",m_operations[i].tsht);
		m_operation_ctrl.SetItemText(k,10,buf);

		buf="";
		if(m_operations[i].t_op) 
		{
			if(floor(m_operations[i].t_op)==m_operations[i].t_op) buf.Format("%d",long(m_operations[i].t_op));
			else buf.Format("%.2f",m_operations[i].t_op);
		}
		m_operation_ctrl.SetItemText(k,11,buf);

		buf="";
		if(m_operations[i].per_amount) buf.Format("%d",m_operations[i].per_amount);
		m_operation_ctrl.SetItemText(k,12,buf);

		buf="";
		if(m_operations[i].soj) m_api->GetItemName(m_operations[i].soj,buf);		
		m_operation_ctrl.SetItemText(k,13,buf);

		buf="";
		if(m_operations[i].instruk) m_api->m_data.GetAttr(m_operations[i].instruk,m_api->m_doc_mgr.a_doc_id,buf);
		m_operation_ctrl.SetItemText(k,14,buf);
		buf="";
		if(m_operations[i].upr_prog) m_api->m_data.GetAttr(m_operations[i].upr_prog,m_api->m_doc_mgr.a_doc_id,buf);
		m_operation_ctrl.SetItemText(k,15,buf);
		m_operation_ctrl.SetItemText(k,16,m_operations[i].razryad);
		buf="";
		if(m_operations[i].ceh) m_api->m_data.GetAttr(m_operations[i].ceh,m_api->m_appr_mgr.a_org_descr,buf); 
		m_operation_ctrl.SetItemText(k,17,buf);
		buf="";
		if(m_operations[i].uchastok) m_api->m_data.GetAttr(m_operations[i].uchastok,m_api->m_appr_mgr.a_org_descr,buf); 
		m_operation_ctrl.SetItemText(k,18,buf);

		m_operation_ctrl.SetItemText(k,19,m_operations[i].rm);

	}
	if(m_operation_ctrl.GetItemCount())
	{
		if(sel<0) sel=0;
		else if(sel>=m_operation_ctrl.GetItemCount()) sel=m_operation_ctrl.GetItemCount()-1;
		m_operation_ctrl.SetItemState(sel,LVIS_SELECTED,-1);
		m_operation_ctrl.EnsureVisible(sel,false);
	}
	UpdatePerehodsCtrl();
	UpdateOsnastkaCtrl();

}

void CTechProcessDlg::UpdatePerehods(OperationStruct *oper,CaplInstance *oper_bp)
{
	if(!oper) return;
	if(oper_bp==0) return;
	if(oper_bp->GetType()==0) return;
	CaplInstance *oper_lock=m_api->m_bp_mgr.CheckMyLock(oper_bp,false);
	aplExtent ext_perehod;
	aplExtent ext_char,ext_group;
	CaplInstance *charact=0;
	if(oper_lock)
		m_api->m_data.GetAttr(oper_lock,m_api->m_bp_mgr.a_bp_ver_elements,ext_perehod);	
	else 
		m_api->m_data.GetAttr(oper_bp,m_api->m_bp_mgr.a_bp_elements,ext_perehod);	
	for(int i=0;i<ext_perehod.GetSize();i++)
	{
		if(ext_perehod[i]->GetAccessmode()>aplRO) continue;
		CaplInstance *perehod_lock=m_api->m_bp_mgr.CheckMyLock(ext_perehod[i],false);
		CaplInstance *type=0;
		if(perehod_lock) m_api->m_data.GetAttr(perehod_lock,m_api->m_bp_mgr.a_bp_ver_type,type);
		else m_api->m_data.GetAttr(ext_perehod[i],m_api->m_bp_mgr.a_bp_type,type); 
		if(type!=m_perehod_bp_type) continue;

		oper->per_amount++;
		PerehodStruct new_elem;
		new_elem.key=m_perehod_next_key;
		new_elem.oper=oper->key;
		new_elem.perehod=ext_perehod[i];
		if(perehod_lock) 
		{
			m_api->m_data.GetAttr(perehod_lock,m_api->m_bp_mgr.a_bp_ver_descr,new_elem.descr);	
			m_api->m_charact_mgr.FindAssociatedCharacteristic(perehod_lock, ext_char,ext_group,false);
		}
		else
		{
			m_api->m_data.GetAttr(ext_perehod[i],m_api->m_bp_mgr.a_bp_descr,new_elem.descr);	
			m_api->m_charact_mgr.FindAssociatedCharacteristic(ext_perehod[i], ext_char,ext_group,false);
		}

		double d_val=0;
		CString s_val;

		for(int l=0;l<ext_char.GetSize();l++)
		{
			bool lock=false;
			if(m_api->m_data.IsKindOf(ext_char[l],m_api->m_charact_mgr.e_apl_charact_value))
			{
				m_api->m_data.GetAttr(ext_char[l],m_api->m_charact_mgr.a_apl_charact_val_charact,charact);
			}
			else
			{
				lock=true;
				m_api->m_data.GetAttr(ext_char[l],m_api->m_charact_mgr.a_apl_charact_val_ver_charact,charact);
			}

			if(charact==m_tper_char)
			{
				if(lock) m_api->m_data.GetAttr(ext_char[l],m_api->m_charact_mgr.a_apl_charact_val_ver_meas_val,d_val);
				else m_api->m_data.GetAttr(ext_char[l],m_api->m_charact_mgr.a_apl_charact_val_meas_val,d_val);
				new_elem.t_per=d_val;
				oper->t_op+=d_val;
			}

			/************************************************************************/
			/*                                                                      */
			/************************************************************************/

			if(charact == m_diametr_char)
			{
				if(lock) m_api->m_data.GetAttr(ext_char[l], m_api->m_charact_mgr.a_apl_charact_val_ver_meas_val, d_val);
				else m_api->m_data.GetAttr(ext_char[l], m_api->m_charact_mgr.a_apl_charact_val_meas_val, d_val);
				new_elem.diametr = d_val;				
			}
			else if(charact == m_dlina_char)
			{
				if(lock) m_api->m_data.GetAttr(ext_char[l], m_api->m_charact_mgr.a_apl_charact_val_ver_meas_val, d_val);
				else m_api->m_data.GetAttr(ext_char[l], m_api->m_charact_mgr.a_apl_charact_val_meas_val, d_val);
				new_elem.dlina = d_val;				
			}
			else if(charact == m_glubina_char)
			{
				if(lock) m_api->m_data.GetAttr(ext_char[l], m_api->m_charact_mgr.a_apl_charact_val_ver_meas_val, d_val);
				else m_api->m_data.GetAttr(ext_char[l], m_api->m_charact_mgr.a_apl_charact_val_meas_val, d_val);
				new_elem.glubina = d_val;				
			}
			else if(charact == m_prohodu_char)
			{
				if(lock) m_api->m_data.GetAttr(ext_char[l], m_api->m_charact_mgr.a_apl_charact_val_ver_meas_val, d_val);
				else m_api->m_data.GetAttr(ext_char[l], m_api->m_charact_mgr.a_apl_charact_val_meas_val, d_val);
				new_elem.prohodu = d_val;				
			}
			else if(charact == m_podacha_char)
			{
				if(lock) m_api->m_data.GetAttr(ext_char[l], m_api->m_charact_mgr.a_apl_charact_val_ver_meas_val, d_val);
				else m_api->m_data.GetAttr(ext_char[l], m_api->m_charact_mgr.a_apl_charact_val_meas_val, d_val);
				new_elem.podacha = d_val;				
			}
			else if(charact == m_shpindel_char)
			{
				if(lock) m_api->m_data.GetAttr(ext_char[l], m_api->m_charact_mgr.a_apl_charact_val_ver_meas_val, d_val);
				else m_api->m_data.GetAttr(ext_char[l], m_api->m_charact_mgr.a_apl_charact_val_meas_val, d_val);
				new_elem.shpindel = d_val;				
			}
			else if(charact == m_skorost_char)
			{
				if(lock) m_api->m_data.GetAttr(ext_char[l], m_api->m_charact_mgr.a_apl_charact_val_ver_meas_val, d_val);
				else m_api->m_data.GetAttr(ext_char[l], m_api->m_charact_mgr.a_apl_charact_val_meas_val, d_val);
				new_elem.skorost = d_val;				
			}
			else if(charact == m_obiem_char)
			{
				if(lock) m_api->m_data.GetAttr(ext_char[l], m_api->m_charact_mgr.a_apl_charact_val_ver_descr_val, s_val);
				else m_api->m_data.GetAttr(ext_char[l], m_api->m_charact_mgr.a_apl_charact_val_descr_val, s_val);
				new_elem.obiem = s_val;				
			}
			else if(charact == m_pi_char)
			{
				if(lock) m_api->m_data.GetAttr(ext_char[l], m_api->m_charact_mgr.a_apl_charact_val_ver_descr_val, s_val);
				else m_api->m_data.GetAttr(ext_char[l], m_api->m_charact_mgr.a_apl_charact_val_descr_val, s_val);
				new_elem.pi = s_val;				
			}
			else if(charact == m_totv_char)
			{
				if(lock) m_api->m_data.GetAttr(ext_char[l], m_api->m_charact_mgr.a_apl_charact_val_ver_meas_val, d_val);
				else m_api->m_data.GetAttr(ext_char[l], m_api->m_charact_mgr.a_apl_charact_val_meas_val, d_val);
				new_elem.totv = d_val;				
			}
		}
		
		m_perehods.Add(new_elem);
		m_perehod_next_key++;
	}

}

void CTechProcessDlg::UpdateOsnastka(PerehodStruct *perehod,CaplInstance *perehod_bp,bool undo_check_out_chars)
{
	if(perehod_bp==0) return;
	if(perehod_bp->GetType()==0) return;
	if(!perehod) return;
	CaplInstance *perehod_lock=m_api->m_bp_mgr.CheckMyLock(perehod_bp,false);
	aplExtent ext_res;
	if(perehod_lock)
		m_api->m_data.GetAttr(perehod_lock,m_api->m_bp_mgr.a_bp_ver_res,ext_res);
	else 
		m_api->m_data.GetAttr(perehod_bp,m_api->m_bp_mgr.a_bp_res,ext_res);

	aplExtent ext_char,ext_group;
	m_api->m_charact_mgr.FindAssociatedCharacteristic(ext_res, ext_char,ext_group);
	//  
	for(int i=0;i<ext_res.GetSize();i++)
	{
		if(ext_res[i]->GetAccessmode()>aplRO) continue;
		perehod->osn_amount++;
		OsnStruct new_elem;
		new_elem.perehod=perehod->key;
		new_elem.resource=ext_res[i];
		m_api->m_data.GetAttr(ext_res[i],m_api->m_bp_mgr.a_bp_res_type,new_elem.res_type);
		m_api->m_data.GetAttr(ext_res[i],m_api->m_bp_mgr.a_bp_res_val,new_elem.amount);
		m_api->m_data.GetAttr(ext_res[i],m_api->m_bp_mgr.a_bp_res_unit,new_elem.ed_izm);
		m_api->m_data.GetAttr(ext_res[i],m_api->m_bp_mgr.a_bp_res_object,new_elem.object);

		m_api->m_charact_mgr.FindAssociatedCharacteristic(ext_res[i], ext_char,ext_group,false,false,false);
		CaplInstance *charact=0;
		for(int j=0;j<ext_char.GetSize();j++)
		{
			m_api->m_data.GetAttr(ext_char[j],m_api->m_charact_mgr.a_apl_charact_val_charact,charact);
			if(charact==m_poz_instr_char)
			{
				if(undo_check_out_chars) m_api->m_charact_mgr.UndoCheckOut(ext_char[j],false);
				CaplInstance *lock=m_api->m_charact_mgr.CheckMyLock(ext_char[j],false);
				if(lock) m_api->m_data.GetAttr(lock,m_api->m_charact_mgr.a_apl_charact_val_ver_descr_val,new_elem.poz_instr);
				else m_api->m_data.GetAttr(ext_char[j],m_api->m_charact_mgr.a_apl_charact_val_descr_val,new_elem.poz_instr);
			}
		}

		m_osnastka.Add(new_elem);
	}

}

void CTechProcessDlg::UpdateOperations(bool undo_check_out_chars)
{
	if(m_bp==0) return;
	if(m_bp->GetType()==0) return;
	m_operations.RemoveAll();
	m_perehods.RemoveAll();
	m_osnastka.RemoveAll();
	aplExtent ext;
	CString buf;
	m_oper_next_key=0;
	m_perehod_next_key=0;
	CaplInstance *lock=m_api->m_bp_mgr.CheckMyLock(m_bp,false);
	if(lock)
		m_api->m_data.GetAttr(lock,m_api->m_bp_mgr.a_bp_ver_elements,ext);	
	else 
		m_api->m_data.GetAttr(m_bp,m_api->m_bp_mgr.a_bp_elements,ext);	

	int i;
	aplExtent ext_oborud;
	for(i=0;i<ext.GetSize();i++)
	{
		if(ext[i]->GetAccessmode()>aplRO) continue;
		CaplInstance *oper_lock=m_api->m_bp_mgr.CheckMyLock(ext[i],false);
		CaplInstance *type=0;
		if(oper_lock) m_api->m_data.GetAttr(oper_lock,m_api->m_bp_mgr.a_bp_ver_type,type);
		else m_api->m_data.GetAttr(ext[i],m_api->m_bp_mgr.a_bp_type,type); 
		if(type!=m_oper_bp_type) continue;

		OperationStruct new_elem;
		new_elem.bp=ext[i];
		new_elem.key=m_oper_next_key;
		CString id="",name="";
		aplExtent ext_char,ext_group;
		aplExtent ext_res;
		if(oper_lock)
		{
			m_api->m_charact_mgr.FindAssociatedCharacteristic(oper_lock, ext_char,ext_group,false);
			m_api->m_data.GetAttr(oper_lock,m_api->m_bp_mgr.a_bp_ver_id,id);
			m_api->m_data.GetAttr(oper_lock,m_api->m_bp_mgr.a_bp_ver_name,name);
			m_api->m_data.GetAttr(oper_lock,m_api->m_bp_mgr.a_bp_ver_res,ext_res);
		}
		else
		{
			m_api->m_charact_mgr.FindAssociatedCharacteristic(ext[i], ext_char,ext_group,false);
			m_api->m_data.GetAttr(ext[i],m_api->m_bp_mgr.a_bp_id,id);
			m_api->m_data.GetAttr(ext[i],m_api->m_bp_mgr.a_bp_name,name);
			m_api->m_data.GetAttr(ext[i],m_api->m_bp_mgr.a_bp_res,ext_res);
		}
		new_elem.id=id;
		new_elem.name=name;

		//
		for(int m=0;m<ext_res.GetSize();m++)
		{
			CaplInstance *res_type=0;
			CaplInstance *object=0;
			m_api->m_data.GetAttr(ext_res[m],m_api->m_bp_mgr.a_bp_res_type,res_type);
			if(res_type==m_oborud_res_type) 
			{
				m_api->m_data.GetAttr(ext_res[m],m_api->m_bp_mgr.a_bp_res_object,new_elem.oborud);
				if(new_elem.oborud) ext_oborud.Add(new_elem.oborud);
				break;
			}
		}

		double dValue=0;
		CString sValue;
		CaplInstance *ciValue=0;
		CaplInstance *charact=0;
		CString val="";
		CaplInstance *ref=0;

		for(int j=0;j<ext_char.GetSize();j++)
		{
			bool lock=false;
			if(m_api->m_data.IsKindOf(ext_char[j],m_api->m_charact_mgr.e_apl_charact_value))
			{
				m_api->m_data.GetAttr(ext_char[j],m_api->m_charact_mgr.a_apl_charact_val_charact,charact);
			}
			else
			{
				lock=true;
				m_api->m_data.GetAttr(ext_char[j],m_api->m_charact_mgr.a_apl_charact_val_ver_charact,charact);
			}
			if(charact==m_mk_ok_char) 
			{
				if(lock) m_api->m_data.GetAttr(ext_char[j],m_api->m_charact_mgr.a_apl_charact_val_ver_enum_val,val);
				else m_api->m_data.GetAttr(ext_char[j],m_api->m_charact_mgr.a_apl_charact_val_enum_val,val);
				new_elem.mk_ok=val;
			}
			else if(charact==m_tp_char)
			{
				if(lock) m_api->m_data.GetAttr(ext_char[j],m_api->m_charact_mgr.a_apl_charact_val_ver_enum_val,val);
				else m_api->m_data.GetAttr(ext_char[j],m_api->m_charact_mgr.a_apl_charact_val_enum_val,val);
				new_elem.tech_passport=val;
			}
			else if(charact==m_razryad_char)
			{
				if(lock) m_api->m_data.GetAttr(ext_char[j],m_api->m_charact_mgr.a_apl_charact_val_ver_enum_val,val);
				else m_api->m_data.GetAttr(ext_char[j],m_api->m_charact_mgr.a_apl_charact_val_enum_val,val);
				new_elem.razryad=val;
			}
			else if(charact==m_ceh_char)
			{
				if(lock) m_api->m_data.GetAttr(ext_char[j],m_api->m_charact_mgr.a_apl_reference_val_ver_val,ref);
				else m_api->m_data.GetAttr(ext_char[j],m_api->m_charact_mgr.a_apl_reference_val,ref);
				new_elem.ceh=ref;
			}
			else if(charact==m_uch_char)
			{
				if(lock) m_api->m_data.GetAttr(ext_char[j],m_api->m_charact_mgr.a_apl_reference_val_ver_val,ref);
				else m_api->m_data.GetAttr(ext_char[j],m_api->m_charact_mgr.a_apl_reference_val,ref);
				new_elem.uchastok=ref;
			}			
			else if(charact == m_hardness_char)
			{
				if(lock) m_api->m_data.GetAttr(ext_char[j], m_api->m_charact_mgr.a_apl_charact_val_ver_descr_val, sValue);
				else m_api->m_data.GetAttr(ext_char[j], m_api->m_charact_mgr.a_apl_charact_val_descr_val, sValue);
				new_elem.hardness = sValue;
			}
			else if(charact == m_to_char)
			{
				if(lock) m_api->m_data.GetAttr(ext_char[j], m_api->m_charact_mgr.a_apl_charact_val_ver_meas_val, dValue);
				else m_api->m_data.GetAttr(ext_char[j], m_api->m_charact_mgr.a_apl_charact_val_meas_val, dValue);
				new_elem.to = dValue;
			}
			else if(charact == m_tv_char)
			{
				if(lock) m_api->m_data.GetAttr(ext_char[j], m_api->m_charact_mgr.a_apl_charact_val_ver_meas_val, dValue);
				else m_api->m_data.GetAttr(ext_char[j], m_api->m_charact_mgr.a_apl_charact_val_meas_val, dValue);
				new_elem.tv = dValue;
			}
			else if(charact == m_tpz_char)
			{
				if(lock) m_api->m_data.GetAttr(ext_char[j], m_api->m_charact_mgr.a_apl_charact_val_ver_meas_val, dValue);
				else m_api->m_data.GetAttr(ext_char[j], m_api->m_charact_mgr.a_apl_charact_val_meas_val, dValue);
				new_elem.tpz = dValue;
			}
			else if(charact == m_tsht_char)
			{
				if(lock) m_api->m_data.GetAttr(ext_char[j], m_api->m_charact_mgr.a_apl_charact_val_ver_meas_val, dValue);
				else m_api->m_data.GetAttr(ext_char[j], m_api->m_charact_mgr.a_apl_charact_val_meas_val, dValue);
				new_elem.tsht = dValue;
			}
			else if(charact == m_soj_char)
			{
				if(lock) m_api->m_data.GetAttr(ext_char[j], m_api->m_charact_mgr.a_apl_reference_val_ver_val, ciValue);
				else m_api->m_data.GetAttr(ext_char[j], m_api->m_charact_mgr.a_apl_reference_val, ciValue);
				new_elem.soj = ciValue;
			}
			else if(charact == m_rm_char)
			{
				if(lock) m_api->m_data.GetAttr(ext_char[j], m_api->m_charact_mgr.a_apl_charact_val_ver_descr_val, sValue);
				else m_api->m_data.GetAttr(ext_char[j], m_api->m_charact_mgr.a_apl_charact_val_descr_val, sValue);
				new_elem.rm = sValue;
			}
		}

		m_operations.Add(new_elem);
		m_oper_next_key++;
		
	}
	for(i=0;i<m_operations.GetSize();i++)
	{
		UpdatePerehods(&m_operations[i],m_operations[i].bp);
	}
	if(ext_oborud.GetSize()) m_api->LoadExtentInfo(ext_oborud);
	aplExtent ext_tmp;
	aplExtent ext_res;
	for(i=0;i<m_perehods.GetSize();i++)
	{
		if(m_perehods[i].perehod)
		{
			CaplInstance *perehod_lock=m_api->m_bp_mgr.CheckMyLock(m_perehods[i].perehod,false);
			if(perehod_lock) m_api->m_data.GetAttr(perehod_lock,m_api->m_bp_mgr.a_bp_ver_res,ext_tmp);
			else m_api->m_data.GetAttr(m_perehods[i].perehod,m_api->m_bp_mgr.a_bp_res,ext_tmp);
			ext_res.Append(ext_tmp);
		}
	}
	if(ext_res.GetSize()) m_api->m_bp_mgr.LoadBPResourcesInfo(ext_res);
	for(i=0;i<m_perehods.GetSize();i++)
	{
		UpdateOsnastka(&m_perehods[i],m_perehods[i].perehod,undo_check_out_chars);
	}
	UpdateOperationsCtrl();	
	
}

void CTechProcessDlg::SetReadOnlyItems()
{
	if(!m_bp) 
	{
		m_check_out_btn.ShowWindow(SW_HIDE);
		m_check_in_btn.ShowWindow(SW_HIDE);
		m_undo_check_out_btn.ShowWindow(SW_HIDE);
	}
	else
	{
		m_check_out_btn.ShowWindow(SW_HIDE);
		m_check_in_btn.ShowWindow(SW_HIDE);
		m_undo_check_out_btn.ShowWindow(SW_HIDE);
		CaplInstance *lock=m_api->m_bp_mgr.GetLock(m_bp,false);
		if(lock)
		{
			if(lock!=m_bp_lock) // - 
			{
				m_ReadOnly=true;
			}
			else // . 
			{
				m_check_in_btn.ShowWindow(SW_SHOW);
				m_undo_check_out_btn.ShowWindow(SW_SHOW);
			}
		}
		else // 
		{
			m_check_out_btn.ShowWindow(SW_SHOW);
		}
	}
	m_el_top_btn.ShowWindow(SW_HIDE);
	m_el_bottom_btn.ShowWindow(SW_HIDE);
	if(m_ReadOnly || (!m_bp_lock && !m_bModeCreate))
	{
		m_id_ctrl.EnableWindow(false);
		m_add_oper_btn.ShowWindow(SW_HIDE);
		m_delete_oper_btn.ShowWindow(SW_HIDE);
		m_add_perehod_btn.ShowWindow(SW_HIDE);
		m_delete_perehod_btn.ShowWindow(SW_HIDE);
		m_add_osn_btn.ShowWindow(SW_HIDE);
		m_delete_osn_btn.ShowWindow(SW_HIDE);
/*		m_el_top_btn.ShowWindow(SW_HIDE);
		m_el_bottom_btn.ShowWindow(SW_HIDE);*/
		m_el_per_top_btn.ShowWindow(SW_HIDE);
		m_el_per_bottom_btn.ShowWindow(SW_HIDE);
		m_material_ctrl.EnableWindow(false);
		m_renumber_btn.EnableWindow(false);
	}
	else
	{
		m_id_ctrl.EnableWindow(true);
		m_add_oper_btn.ShowWindow(SW_SHOW);
		m_delete_oper_btn.ShowWindow(SW_SHOW);
		m_add_perehod_btn.EnableWindow(true);
		m_add_osn_btn.EnableWindow(true);
		m_add_perehod_btn.ShowWindow(SW_SHOW);
		m_delete_perehod_btn.ShowWindow(SW_SHOW);
		m_add_osn_btn.ShowWindow(SW_SHOW);
		m_delete_osn_btn.ShowWindow(SW_SHOW);
		m_delete_osn_btn.EnableWindow(true);
		m_delete_oper_btn.EnableWindow(true);
		m_renumber_btn.EnableWindow(true);
		m_delete_perehod_btn.EnableWindow(true);
		m_material_ctrl.EnableWindow(true);
		if(!m_combo.GetCount()) m_add_oper_btn.EnableWindow(false);
		if(m_operation_ctrl.GetItemCount()>1)
		{

		}
		else
		{
			if(!m_operation_ctrl.GetItemCount()) 
			{
				m_renumber_btn.EnableWindow(false);
				m_add_perehod_btn.EnableWindow(false);
				m_delete_perehod_btn.EnableWindow(false);
				m_delete_oper_btn.EnableWindow(false);
				m_delete_osn_btn.EnableWindow(false);
				m_add_osn_btn.EnableWindow(false);
			}
		}
		if(m_perehod_ctrl.GetItemCount()>1)
		{
			m_el_per_top_btn.ShowWindow(SW_SHOW);
			m_el_per_bottom_btn.ShowWindow(SW_SHOW);
		}
		else
		{
			if(!m_perehod_ctrl.GetItemCount()) 
			{
				m_add_osn_btn.EnableWindow(false);
				m_delete_osn_btn.EnableWindow(false);
				m_delete_perehod_btn.EnableWindow(false);
			}
			m_el_per_top_btn.ShowWindow(SW_HIDE);
			m_el_per_bottom_btn.ShowWindow(SW_HIDE);
		}
		if(!m_osnastka_ctrl.GetItemCount())
		{
			m_delete_osn_btn.EnableWindow(false);
		}
	}

}

void CTechProcessDlg::OnCheckOut() 
{
	CDisAsmStatusDlg status_dlg;
	bool status_dlg_created=false;
	int status_count=0;
	if(status_dlg.Create(IDD_DISASM_STATUS)) 
	{
		status_dlg_created=true;
		status_dlg.m_name.SetWindowText(" :");
		status_dlg.ShowWindow(TRUE);
	}

	bool old_ModeInteractive=m_api->m_ModeInteractive;
	m_api->m_ModeInteractive=false;
	bool old_AS = m_api->m_bp_mgr.m_AutoSave;
	m_api->m_bp_mgr.m_AutoSave = false;
	bool old_AS_char = m_api->m_charact_mgr.m_AutoSave;
	m_api->m_charact_mgr.m_AutoSave = false;
	CString buf;
	if(m_api->m_bp_mgr.CheckOut(m_bp,false))
	{
		status_count++;
		buf.Format("%d",status_count);
		status_dlg.m_count.SetWindowText(buf);
		aplExtent ext_sub;
		m_api->m_bp_mgr.GetAllSubBP(m_bp,ext_sub);
		for(int i=0;i<ext_sub.GetSize();i++)
		{
			CaplInstance *type=0;
			m_api->m_data.GetAttr(ext_sub[i],m_api->m_bp_mgr.a_bp_type,type);
			if(type==m_oper_bp_type || type==m_perehod_bp_type) 
			{
				m_api->m_bp_mgr.CheckOut(ext_sub[i],true);
				buf.Format("%d",status_count);
				status_dlg.m_count.SetWindowText(buf);
				status_count++;
			}
		}
		m_bp_lock=m_api->m_bp_mgr.CheckMyLock(m_bp,false);
		SetReadOnlyItems();
	}
	m_api->m_ModeInteractive=old_ModeInteractive;
	m_api->m_bp_mgr.m_AutoSave = old_AS;
	m_api->m_charact_mgr.m_AutoSave= old_AS_char;
	m_api->m_data.NET_SaveChanges();
	status_dlg.ShowWindow(FALSE);
}

bool CTechProcessDlg::CheckIn()
{
	if(AfxMessageBox("  ?", MB_YESNO|MB_ICONQUESTION)==IDNO) return false;
	if(!SaveChanges(true)) 
	{
		return false;
	}
	bool old_ModeInteractive_bp=m_api->m_ModeInteractive;
	bool old_AS = m_api->m_bp_mgr.m_AutoSave;
	m_api->m_bp_mgr.m_AutoSave = false;
	bool old_AS_char = m_api->m_charact_mgr.m_AutoSave;
	m_api->m_charact_mgr.m_AutoSave = false;
	m_api->m_ModeInteractive=false;
	m_api->m_bp_mgr.m_undo_check_out=true;
	m_api->m_bp_mgr.m_apply_to_all=true;
	bool make_active=true;
	if(m_bp->GetAccessmode()>aplOWN) 
	{
		make_active=false;
		AfxMessageBox("     ,     !");
	}
	if(m_api->m_bp_mgr.CheckIn(m_bp,true,make_active))
	{
		m_bp_lock=0;
		SetReadOnlyItems();
	}
	m_api->m_bp_mgr.m_AutoSave = old_AS;
	m_api->m_ModeInteractive=old_ModeInteractive_bp;
	m_api->m_charact_mgr.m_AutoSave=old_AS_char;
	m_api->m_data.NET_SaveChanges();
	return true;
}

void CTechProcessDlg::OnCheckIn() 
{
	CheckIn();
}

void CTechProcessDlg::OnUndoCheckOut() 
{
	if(AfxMessageBox("  ?", MB_YESNO|MB_ICONQUESTION)==IDNO) return;
	if(AfxMessageBox(" ,     ?", MB_YESNO|MB_ICONQUESTION)==IDNO) return;
	bool old_ModeInteractive_bp=m_api->m_ModeInteractive;
	bool old_AS = m_api->m_bp_mgr.m_AutoSave;
	m_api->m_bp_mgr.m_AutoSave = false;
	bool old_AS_char = m_api->m_charact_mgr.m_AutoSave;
	m_api->m_charact_mgr.m_AutoSave = false;
	m_api->m_ModeInteractive=false;
	m_api->m_bp_mgr.m_undo_check_out=true;
	m_api->m_bp_mgr.m_apply_to_all=true;
	if(m_api->m_bp_mgr.UndoCheckOut(m_bp,true))
	{
		m_bp_lock=0;
		if(m_bp)
		{
			CString buf;
			m_api->m_data.GetAttr(m_bp,m_api->m_bp_mgr.a_bp_id,buf);
			m_id_ctrl.SetWindowText(buf);
		}
		UpdateOperations(true);	
		LoadDocs();
		UpdateOperationsCtrl();	
		UpdatePerehodsCtrl();
		SetReadOnlyItems();
	}
	m_api->m_bp_mgr.m_AutoSave = old_AS;
	m_api->m_ModeInteractive=old_ModeInteractive_bp;
	m_api->m_charact_mgr.m_AutoSave=old_AS_char;
	m_api->m_data.NET_SaveChanges();
}

OperationStruct::OperationStruct()
{
	key=0;
	bp=0;
	id="";
	name="";
	oborud=0;
	t_op=0;
	mk_ok="";
	tech_passport="";
	per_amount=0;
	instruk=0;
	upr_prog=0;
	instruk_rel=0;
	upr_prog_rel=0;
	razryad="";
	ceh=0;
	uchastok=0;	
	soj=0;
	to=0;
	tv=0;
	tpz=0;
	tsht=0;
}

OsnStruct::OsnStruct()
{
	ed_izm=0;
	perehod=0;
	resource=0;
	res_type=0;
	object=0;
	amount=0;
	poz_instr="";
}

void CTechProcessDlg::OnElTop() 
{
	if(m_edit_oper || m_edit_perehod || m_edit_osn) return;
	int k=m_operation_ctrl.GetNextItem(-1,LVNI_SELECTED)-1;
	int k1=k+1;
	
	if(k<0)  return;
	if(k>m_operation_ctrl.GetItemCount()-2) return;

	OperationStruct tmp=m_operations[k];
	m_operations.SetAt(k,m_operations[k1]);
	m_operations.SetAt(k1,tmp);

	m_operation_ctrl.SetItemState(k,LVIS_SELECTED,-1);	

	UpdateOperationsCtrl();	

}

void CTechProcessDlg::OnElBottom() 
{
	if(m_edit_oper || m_edit_perehod || m_edit_osn) return;
	int k=m_operation_ctrl.GetNextItem(-1,LVNI_SELECTED);
	int k1=k+1;
	
	if(k<0)  return;
	if(k>m_operation_ctrl.GetItemCount()-2) return;

	OperationStruct tmp=m_operations[k];
	m_operations.SetAt(k,m_operations[k1]);
	m_operations.SetAt(k1,tmp);

	m_operation_ctrl.SetItemState(k+1,LVIS_SELECTED,-1);
	UpdateOperationsCtrl();
}

bool CTechProcessDlg::SaveChanges(bool check_in_chars)
{
	if(!m_bp_lock && !m_bModeCreate) return true;
	if(!EndEdit()) return false;
	long trd=aplStartWaitDlg("  ");
	aplExtent ext_oper;
	CString buf;
	aplExtent ext_tp;
	CaplInstance *ref=0;
	m_id_ctrl.GetWindowText(buf);
	if(buf=="") {aplEndWaitDlg(trd);AfxMessageBox(" \"\"   !"); 	return false;}
	if(m_cur_org_id.Find("")>-1)
	{
		if(buf.GetLength()!=5)
		{
			aplEndWaitDlg(trd);
			AfxMessageBox("     5 !"); 	
			return false;
		}
	}
	else if(m_cur_org_id.Find("")>-1)
	{
		if(buf.GetLength()!=11 || buf.Find('.')!=5)
		{
			aplEndWaitDlg(trd);
			AfxMessageBox("     \"xxxxx.xxxxx\" !"); 	
			return false;
		}
	}
	CString old_id="";
	if(m_bp) 
	{
		m_bp_lock=m_api->m_bp_mgr.CheckMyLock(m_bp,false);
		if(m_bp_lock) m_api->m_data.GetAttr(m_bp_lock,m_api->m_bp_mgr.a_bp_ver_id,old_id);
		else m_api->m_data.GetAttr(m_bp,m_api->m_bp_mgr.a_bp_id,old_id);
	}
	if(buf!=old_id) 
	{
		//  id
		CaplAttrValue tst_values[1];				
		tst_values[0].value.Set((LPCSTR)buf); 
		tst_values[0].attr=m_api->m_bp_mgr.a_bp_id;      
		if(!m_api->m_data.NET_TestUniqueAttrValues(m_api->m_bp_mgr.e_bp,m_bp,1,&tst_values[0], false)) 
		{
			aplEndWaitDlg(trd);
			AfxMessageBox("        !!!");
			return false;
		}
	}
	if(!m_bp)
	{
		m_bp=m_api->m_bp_mgr.CreateBP(0,m_pdf,buf," ",m_tp_bp_type,APL_MODE_CREATE_BP,&m_bp_ref,0,0,0,0,false);
		m_bp_lock=m_api->m_bp_mgr.CheckMyLock(m_bp,false);
	}
	else 
	{
		if(buf!=old_id) if(m_bp_lock) m_api->m_data.PutAttr(m_bp_lock,m_api->m_bp_mgr.a_bp_ver_id,buf);
	}
	if(!m_bp || !m_bp_lock) 
	{
		aplEndWaitDlg(trd);
		return true;
	}
	bool old_AS = m_api->m_bp_mgr.m_AutoSave;
	bool old_AS_char = m_api->m_charact_mgr.m_AutoSave;
	m_api->m_bp_mgr.m_AutoSave = false;
	m_api->m_charact_mgr.m_AutoSave=false;
	if(m_bp_ref)
	{
		CaplInstance *old_zagotov=0;
		m_api->m_data.GetAttr(m_bp_ref,m_api->m_bp_mgr.a_bp_ref_zagotov,old_zagotov);
		int cur_sel=m_material_ctrl.GetCurSel();
		CaplInstance *zagotov=(CaplInstance*)m_material_ctrl.GetItemData(cur_sel);
		if(zagotov!=old_zagotov) m_api->m_data.PutAttr(m_bp_ref,m_api->m_bp_mgr.a_bp_ref_zagotov,zagotov);
	}

	int i;
	CString op_num;
/*	CaplAttrValue tst_values[2];				
	tst_values[0].attr=m_api->m_bp_mgr.a_bp_id;    
	tst_values[1].attr=m_api->m_bp_mgr.a_bp_parent;*/
	for(i=0;i<m_operations.GetSize();i++) 
	{
		op_num.Format("%d",i+1);
/*		//  id
		tst_values[0].value.Set((LPCSTR)m_operations[i].id); 
		tst_values[1].value.Set(m_bp);
		if(!m_api->m_data.NET_TestUniqueAttrValues(m_api->m_bp_mgr.e_bp,m_operations[i].bp,2,&tst_values[0], false)) 
		{
			aplEndWaitDlg(trd);
			AfxMessageBox("  "+op_num+"  !!!");
			return false;
		}	*/
		if(m_operations[i].name=="") 
		{
			aplEndWaitDlg(trd);
			AfxMessageBox("    "+op_num);
			return false;
		}
	}

	bool oldCheckUniqs=m_api->m_bp_mgr.m_bCheckUniqs;
	m_api->m_bp_mgr.m_bCheckUniqs=false;
	for(i=0;i<m_operations.GetSize();i++) 
	{
		if(!m_operations[i].bp) 
		{
			m_operations[i].bp=m_api->m_bp_mgr.CreateBP(m_bp,0,m_operations[i].id,0,m_oper_bp_type,APL_MODE_CREATE_BP,0,0,0,0,0,false);
		}
		if(m_operations[i].bp) 
		{
			ext_oper.Add(m_operations[i].bp);
			CaplInstance *oper_lock=m_api->m_bp_mgr.CheckMyLock(m_operations[i].bp,false);
			if(oper_lock) 
			{
				m_api->m_data.GetAttr(oper_lock,m_api->m_bp_mgr.a_bp_ver_id,buf);
				if(m_operations[i].id!=buf) m_api->m_data.PutAttr(oper_lock,m_api->m_bp_mgr.a_bp_ver_id,m_operations[i].id);
				m_api->m_data.GetAttr(oper_lock,m_api->m_bp_mgr.a_bp_ver_name,buf);
				if(m_operations[i].name!=buf) m_api->m_data.PutAttr(oper_lock,m_api->m_bp_mgr.a_bp_ver_name,m_operations[i].name);

				double dValue=0;
				aplExtent ext_char,ext_group;
				m_api->m_charact_mgr.FindAssociatedCharacteristic(oper_lock, ext_char,ext_group,false);
				CaplInstance *charact=0;
				CString val="", sValue="";
				bool found_mk_ok=false;
				bool found_tp=false;
				bool found_razryad=false;
				bool found_ceh=false;
				bool found_uch=false;

				bool found_hardness = false;
				bool found_to = false;
				bool found_tv = false;
				bool found_tpz = false;
				bool found_tsht = false;
				bool found_soj = false;
				bool found_rm = false;

				for(int j=0;j<ext_char.GetSize();j++)
				{
					m_api->m_data.GetAttr(ext_char[j],m_api->m_charact_mgr.a_apl_charact_val_ver_charact,charact);
					if(!charact) continue;
					if(charact==m_mk_ok_char) 
					{
						m_api->m_data.GetAttr(ext_char[j],m_api->m_charact_mgr.a_apl_charact_val_ver_enum_val,buf);
						if(buf!=m_operations[i].mk_ok) 
						{
							m_api->m_data.PutAttr(ext_char[j],m_api->m_charact_mgr.a_apl_charact_val_ver_enum_val,m_operations[i].mk_ok);
							m_api->m_data.PutAttr(ext_char[j],m_api->m_charact_mgr.a_apl_charact_val_ver_is_changed,true);
						}
						found_mk_ok=true;
					}
					else if(charact==m_tp_char)
					{
						m_api->m_data.GetAttr(ext_char[j],m_api->m_charact_mgr.a_apl_charact_val_ver_enum_val,buf);
						if(buf!=m_operations[i].tech_passport) 
						{
							m_api->m_data.PutAttr(ext_char[j],m_api->m_charact_mgr.a_apl_charact_val_ver_enum_val,m_operations[i].tech_passport);
							m_api->m_data.PutAttr(ext_char[j],m_api->m_charact_mgr.a_apl_charact_val_ver_is_changed,true);
						}
						found_tp=true;
					}
					else if(charact==m_razryad_char)
					{
						m_api->m_data.GetAttr(ext_char[j],m_api->m_charact_mgr.a_apl_charact_val_ver_enum_val,buf);
						if(buf!=m_operations[i].razryad) 
						{
							m_api->m_data.PutAttr(ext_char[j],m_api->m_charact_mgr.a_apl_charact_val_ver_enum_val,m_operations[i].razryad);
							m_api->m_data.PutAttr(ext_char[j],m_api->m_charact_mgr.a_apl_charact_val_ver_is_changed,true);
						}
						found_razryad=true;
					}
					else if(charact==m_ceh_char)
					{
						m_api->m_data.GetAttr(ext_char[j],m_api->m_charact_mgr.a_apl_reference_val_ver_val,ref);
						if(ref!=m_operations[i].ceh) 
						{
							m_api->m_data.PutAttr(ext_char[j],m_api->m_charact_mgr.a_apl_reference_val_ver_val,m_operations[i].ceh);
							m_api->m_data.PutAttr(ext_char[j],m_api->m_charact_mgr.a_apl_charact_val_ver_is_changed,true);
						}
						found_ceh=true;
					}
					else if(charact==m_uch_char)
					{
						m_api->m_data.GetAttr(ext_char[j],m_api->m_charact_mgr.a_apl_reference_val_ver_val,ref);
						if(ref!=m_operations[i].uchastok) 
						{
							m_api->m_data.PutAttr(ext_char[j],m_api->m_charact_mgr.a_apl_reference_val_ver_val,m_operations[i].uchastok);
							m_api->m_data.PutAttr(ext_char[j],m_api->m_charact_mgr.a_apl_charact_val_ver_is_changed,true);
						}
						found_uch=true;
					}
					//////////////////////////////////////////////////////////////////////////
					else if(charact==m_hardness_char)
					{
						m_api->m_data.GetAttr(ext_char[j],m_api->m_charact_mgr.a_apl_charact_val_ver_descr_val, sValue);
						if(0 != m_operations[i].hardness.Compare(sValue)) 
						{
							m_api->m_data.PutAttr(ext_char[j],m_api->m_charact_mgr.a_apl_charact_val_ver_descr_val, m_operations[i].hardness);
							m_api->m_data.PutAttr(ext_char[j],m_api->m_charact_mgr.a_apl_charact_val_ver_is_changed,true);
						}
						found_hardness=true;
					}
					else if(charact==m_to_char)
					{
						m_api->m_data.GetAttr(ext_char[j],m_api->m_charact_mgr.a_apl_charact_val_ver_meas_val, dValue);
						if(dValue != m_operations[i].to) 
						{
							m_api->m_data.PutAttr(ext_char[j],m_api->m_charact_mgr.a_apl_charact_val_ver_meas_val, m_operations[i].to);
							m_api->m_data.PutAttr(ext_char[j],m_api->m_charact_mgr.a_apl_charact_val_ver_is_changed,true);
						}
						found_to=true;
					}
					else if(charact==m_tv_char)
					{
						m_api->m_data.GetAttr(ext_char[j],m_api->m_charact_mgr.a_apl_charact_val_ver_meas_val, dValue);
						if(dValue != m_operations[i].tv) 
						{
							m_api->m_data.PutAttr(ext_char[j],m_api->m_charact_mgr.a_apl_charact_val_ver_meas_val, m_operations[i].tv);
							m_api->m_data.PutAttr(ext_char[j],m_api->m_charact_mgr.a_apl_charact_val_ver_is_changed,true);
						}
						found_tv=true;
					}
					else if(charact==m_tpz_char)
					{
						m_api->m_data.GetAttr(ext_char[j],m_api->m_charact_mgr.a_apl_charact_val_ver_meas_val, dValue);
						if(dValue != m_operations[i].tpz) 
						{
							m_api->m_data.PutAttr(ext_char[j],m_api->m_charact_mgr.a_apl_charact_val_ver_meas_val, m_operations[i].tpz);
							m_api->m_data.PutAttr(ext_char[j],m_api->m_charact_mgr.a_apl_charact_val_ver_is_changed,true);
						}
						found_tpz=true;
					}
					else if(charact==m_tsht_char)
					{
						m_api->m_data.GetAttr(ext_char[j],m_api->m_charact_mgr.a_apl_charact_val_ver_meas_val, dValue);
						if(dValue != m_operations[i].tsht) 
						{
							m_api->m_data.PutAttr(ext_char[j],m_api->m_charact_mgr.a_apl_charact_val_ver_meas_val, m_operations[i].tsht);
							m_api->m_data.PutAttr(ext_char[j],m_api->m_charact_mgr.a_apl_charact_val_ver_is_changed,true);
						}
						found_tsht=true;
					}
					else if(charact==m_soj_char)
					{
						m_api->m_data.GetAttr(ext_char[j],m_api->m_charact_mgr.a_apl_reference_val_ver_val, ref);
						if(ref != m_operations[i].soj) 
						{
							m_api->m_data.PutAttr(ext_char[j],m_api->m_charact_mgr.a_apl_reference_val_ver_val, m_operations[i].soj);
							m_api->m_data.PutAttr(ext_char[j],m_api->m_charact_mgr.a_apl_charact_val_ver_is_changed,true);
						}
						found_soj=true;
					}
					else if(charact==m_rm_char)
					{
						m_api->m_data.GetAttr(ext_char[j],m_api->m_charact_mgr.a_apl_charact_val_ver_descr_val, sValue);
						if(0 != m_operations[i].rm.Compare(sValue)) 
						{
							m_api->m_data.PutAttr(ext_char[j],m_api->m_charact_mgr.a_apl_charact_val_ver_descr_val, m_operations[i].rm);
							m_api->m_data.PutAttr(ext_char[j],m_api->m_charact_mgr.a_apl_charact_val_ver_is_changed,true);
						}
						found_rm=true;
					}
				}
				if(!found_mk_ok && m_mk_ok_char)
				{
					if(m_operations[i].mk_ok!="") 
					{
						CaplInstance *new_val=m_api->m_charact_mgr.CreateEnumerationCharacteristic(m_operations[i].bp,m_mk_ok_char, 0, m_operations[i].mk_ok);
						if(new_val) 
						{
							CaplInstance *act_ver=0;
							m_api->m_data.GetAttr(new_val,m_api->m_charact_mgr.a_apl_charact_val_act_ver,act_ver);
							if(act_ver) m_api->m_data.PutAttr(new_val,m_api->m_charact_mgr.a_apl_charact_val_lock_ver,act_ver);
						}
					}
				}
				if(!found_tp && m_tp_char)
				{
					if(m_operations[i].tech_passport!="") 
					{
						CaplInstance *new_val=m_api->m_charact_mgr.CreateEnumerationCharacteristic(m_operations[i].bp,m_tp_char, 0, m_operations[i].tech_passport);
						if(new_val) 
						{
							CaplInstance *act_ver=0;
							m_api->m_data.GetAttr(new_val,m_api->m_charact_mgr.a_apl_charact_val_act_ver,act_ver);
							if(act_ver) m_api->m_data.PutAttr(new_val,m_api->m_charact_mgr.a_apl_charact_val_lock_ver,act_ver);
						}
					}
				}
				if(!found_razryad && m_razryad_char)
				{
					if(m_operations[i].razryad!="") 
					{
						CaplInstance *new_val=m_api->m_charact_mgr.CreateEnumerationCharacteristic(m_operations[i].bp,m_razryad_char,0, m_operations[i].razryad);
						if(new_val) 
						{
							CaplInstance *act_ver=0;
							m_api->m_data.GetAttr(new_val,m_api->m_charact_mgr.a_apl_charact_val_act_ver,act_ver);
							if(act_ver) m_api->m_data.PutAttr(new_val,m_api->m_charact_mgr.a_apl_charact_val_lock_ver,act_ver);
						}
					}
				}

				if(!found_ceh && m_ceh_char)
				{
					if(m_operations[i].ceh!=0) 
					{
						CaplInstance *new_val=m_api->m_charact_mgr.CreateReferenceCharacteristic(m_operations[i].bp,m_ceh_char,0, m_operations[i].ceh);
						if(new_val) 
						{
							CaplInstance *act_ver=0;
							m_api->m_data.GetAttr(new_val,m_api->m_charact_mgr.a_apl_charact_val_act_ver,act_ver);
							if(act_ver) m_api->m_data.PutAttr(new_val,m_api->m_charact_mgr.a_apl_charact_val_lock_ver,act_ver);
						}
					}
				}
				if(!found_uch && m_uch_char)
				{
					if(m_operations[i].uchastok!=0) 
					{
						CaplInstance *new_val=m_api->m_charact_mgr.CreateReferenceCharacteristic(m_operations[i].bp,m_uch_char,0, m_operations[i].uchastok);
						if(new_val) 
						{
							CaplInstance *act_ver=0;
							m_api->m_data.GetAttr(new_val,m_api->m_charact_mgr.a_apl_charact_val_act_ver,act_ver);
							if(act_ver) m_api->m_data.PutAttr(new_val,m_api->m_charact_mgr.a_apl_charact_val_lock_ver,act_ver);
						}
					}
				}
				if(!found_hardness && m_hardness_char)
				{
					if(false == m_operations[i].hardness.IsEmpty()) 
					{
						CaplInstance *new_val=m_api->m_charact_mgr.CreateDescriptiveCharacteristic(m_operations[i].bp, m_hardness_char, 0, m_operations[i].hardness);
						if(new_val) 
						{
							CaplInstance *act_ver=0;
							m_api->m_data.GetAttr(new_val,m_api->m_charact_mgr.a_apl_charact_val_act_ver,act_ver);
							if(act_ver) m_api->m_data.PutAttr(new_val,m_api->m_charact_mgr.a_apl_charact_val_lock_ver,act_ver);
						}
					}
				}
				if(!found_to && m_to_char)
				{
					if(m_operations[i].to != 0) 
					{
						CaplInstance *new_val=m_api->m_charact_mgr.CreateMeasuredCharacteristic(m_operations[i].bp, m_to_char, 0, m_operations[i].to, 0, 0);
						if(new_val) 
						{
							CaplInstance *act_ver=0;
							m_api->m_data.GetAttr(new_val,m_api->m_charact_mgr.a_apl_charact_val_act_ver,act_ver);
							if(act_ver) m_api->m_data.PutAttr(new_val,m_api->m_charact_mgr.a_apl_charact_val_lock_ver,act_ver);
						}
					}
				}
				if(!found_tv && m_tv_char)
				{
					if(m_operations[i].tv != 0) 
					{
						CaplInstance *new_val=m_api->m_charact_mgr.CreateMeasuredCharacteristic(m_operations[i].bp, m_tv_char, 0, m_operations[i].tv, 0, 0);
						if(new_val) 
						{
							CaplInstance *act_ver=0;
							m_api->m_data.GetAttr(new_val,m_api->m_charact_mgr.a_apl_charact_val_act_ver,act_ver);
							if(act_ver) m_api->m_data.PutAttr(new_val,m_api->m_charact_mgr.a_apl_charact_val_lock_ver,act_ver);
						}
					}
				}
				if(!found_tpz && m_tpz_char)
				{
					if(m_operations[i].tpz != 0) 
					{
						CaplInstance *new_val=m_api->m_charact_mgr.CreateMeasuredCharacteristic(m_operations[i].bp, m_tpz_char, 0, m_operations[i].tpz, 0, 0);
						if(new_val) 
						{
							CaplInstance *act_ver=0;
							m_api->m_data.GetAttr(new_val,m_api->m_charact_mgr.a_apl_charact_val_act_ver,act_ver);
							if(act_ver) m_api->m_data.PutAttr(new_val,m_api->m_charact_mgr.a_apl_charact_val_lock_ver,act_ver);
						}
					}
				}
				if(!found_tsht && m_tsht_char)
				{
					if(m_operations[i].tsht != 0) 
					{
						CaplInstance *new_val=m_api->m_charact_mgr.CreateMeasuredCharacteristic(m_operations[i].bp, m_tsht_char, 0, m_operations[i].tsht, 0, 0);
						if(new_val) 
						{
							CaplInstance *act_ver=0;
							m_api->m_data.GetAttr(new_val,m_api->m_charact_mgr.a_apl_charact_val_act_ver,act_ver);
							if(act_ver) m_api->m_data.PutAttr(new_val,m_api->m_charact_mgr.a_apl_charact_val_lock_ver,act_ver);
						}
					}
				}
				if(!found_soj && m_soj_char)
				{
					if(m_operations[i].soj != 0) 
					{
						CaplInstance *new_val=m_api->m_charact_mgr.CreateReferenceCharacteristic(m_operations[i].bp, m_soj_char, 0, m_operations[i].soj);
						if(new_val) 
						{
							CaplInstance *act_ver=0;
							m_api->m_data.GetAttr(new_val,m_api->m_charact_mgr.a_apl_charact_val_act_ver,act_ver);
							if(act_ver) m_api->m_data.PutAttr(new_val,m_api->m_charact_mgr.a_apl_charact_val_lock_ver,act_ver);
						}
					}
				}
				if(!found_rm && m_rm_char)
				{
					if(false == m_operations[i].rm.IsEmpty()) 
					{
						CaplInstance *new_val=m_api->m_charact_mgr.CreateDescriptiveCharacteristic(m_operations[i].bp, m_rm_char, 0, m_operations[i].rm);
						if(new_val) 
						{
							CaplInstance *act_ver=0;
							m_api->m_data.GetAttr(new_val,m_api->m_charact_mgr.a_apl_charact_val_act_ver,act_ver);
							if(act_ver) m_api->m_data.PutAttr(new_val,m_api->m_charact_mgr.a_apl_charact_val_lock_ver,act_ver);
						}
					}
				}

				//
				bool found_oborud=false;
				bool oborud_changed=false;
				aplExtent ext_res;
				m_api->m_data.GetAttr(oper_lock,m_api->m_bp_mgr.a_bp_ver_res,ext_res);
				int change_num=0;
				for(int m=0;m<ext_res.GetSize();m++)
				{
					CaplInstance *res_type=0;
					CaplInstance *object=0;
					m_api->m_data.GetAttr(ext_res[m],m_api->m_bp_mgr.a_bp_res_type,res_type);
					if(res_type==m_oborud_res_type) 
					{
						found_oborud=true;
						m_api->m_data.GetAttr(ext_res[m],m_api->m_bp_mgr.a_bp_res_object,object);
						if(m_operations[i].oborud!=object) 
						{
							change_num=m;
							oborud_changed=true;
						}
						break;
					}
				}
				if((!found_oborud || oborud_changed) && m_operations[i].oborud)
				{
					CaplInstance *new_res=m_api->m_data.CreateInstance(m_api->m_bp_mgr.e_bp_res);
					if(new_res)
					{
						m_api->m_data.PutAttr(new_res,m_api->m_bp_mgr.a_bp_res_process,m_operations[i].bp);
						m_api->m_data.PutAttr(new_res,m_api->m_bp_mgr.a_bp_res_object,m_operations[i].oborud);
						m_api->m_data.PutAttr(new_res,m_api->m_bp_mgr.a_bp_res_type,m_oborud_res_type);
						m_api->m_data.PutAttr(new_res,m_api->m_bp_mgr.a_bp_res_val,(double)1);
						if(m_sht_unit) m_api->m_data.PutAttr(new_res,m_api->m_bp_mgr.a_bp_res_unit,m_sht_unit);
						
						if(oborud_changed) ext_res.SetAt(change_num,new_res);
						else ext_res.Add(new_res);
						m_api->m_data.PutAttr(oper_lock,m_api->m_bp_mgr.a_bp_ver_res,ext_res);
					}
				}
			}
		}
		
	}
	if(m_bp_lock) 
	{
		//   ,   ""
		aplExtent ext_old;
		m_api->m_data.GetAttr(m_bp_lock,m_api->m_bp_mgr.a_bp_ver_elements,ext_old);
		for(i=0;i<ext_old.GetSize();i++)
		{
			CaplInstance *type=0;
			CaplInstance *oper_lock=m_api->m_bp_mgr.CheckMyLock(ext_old[i],false);
			if(oper_lock) m_api->m_data.GetAttr(oper_lock,m_api->m_bp_mgr.a_bp_ver_type,type);
			else m_api->m_data.GetAttr(ext_old[i],m_api->m_bp_mgr.a_bp_type,type);
			if(type!=m_oper_bp_type) 
			{
				if(i<ext_oper.GetSize()) 
					ext_oper.Insert(i,ext_old[i]);
				else 
					ext_oper.Add(ext_old[i]);
			}
		}
		m_api->m_data.PutAttr(m_bp_lock,m_api->m_bp_mgr.a_bp_ver_elements,ext_oper);
	}

	COleDateTime dt=COleDateTime::GetCurrentTime();
	CString sCurTime;
	aplDate2String(dt,sCurTime);
	int iPerCounter=0;

	//
	for(i=0;i<m_perehods.GetSize();i++) 
	{
		if(!m_perehods[i].perehod) 
		{
			iPerCounter++;
			buf.Format("%s-%i",LPCSTR(sCurTime),iPerCounter);
			
			// 10.03.2010  ayatsk, ..  .   .
			/*
			//  id
			CaplAttrValue tst_values[1];				
			tst_values[0].value.Set((LPCSTR)buf); 
			tst_values[0].attr=m_api->m_bp_mgr.a_bp_id;      
			while (!m_api->m_data.NET_TestUniqueAttrValues(m_api->m_bp_mgr.e_bp,0,1,&tst_values[0], false)) 
			{
				buf+="0";
				tst_values[0].value.Set((LPCSTR)buf); 
			}*/

			m_perehods[i].perehod=m_api->m_bp_mgr.CreateBP(0,0,buf,0,m_perehod_bp_type,APL_MODE_CREATE_BP,0,0,0,0,0,false);
			
		}
		if(m_perehods[i].perehod) 
		{
			CaplInstance *perehod_lock=m_api->m_bp_mgr.CheckMyLock(m_perehods[i].perehod,false);
			if(perehod_lock) 
			{
				m_api->m_data.GetAttr(perehod_lock,m_api->m_bp_mgr.a_bp_ver_descr,buf);
				if(m_perehods[i].descr!=buf) m_api->m_data.PutAttr(perehod_lock,m_api->m_bp_mgr.a_bp_ver_descr,m_perehods[i].descr);
				if(m_tper_char) 
				{
					aplExtent ext_char,ext_group;
					m_api->m_charact_mgr.FindAssociatedCharacteristic(perehod_lock, ext_char,ext_group,false);
					CaplInstance *charact=0;
					double val=0;
					CString s_val;

					bool found_tper=false;
					bool found_diametr = false;
					bool found_dlina = false;
					bool found_glubina = false;
					bool found_prohodu = false;
					bool found_podacha = false;
					bool found_shpindel = false;
					bool found_skorost = false;
					bool found_obiem = false;
					bool found_pi = false;
					bool found_totv = false;
					
					for(int j=0;j<ext_char.GetSize();j++)
					{
						m_api->m_data.GetAttr(ext_char[j],m_api->m_charact_mgr.a_apl_charact_val_ver_charact,charact);

						if(charact==m_tper_char) 
						{
							m_api->m_data.GetAttr(ext_char[j],m_api->m_charact_mgr.a_apl_charact_val_ver_meas_val,val);
							if(val!=m_perehods[i].t_per) 
							{
								m_api->m_data.PutAttr(ext_char[j],m_api->m_charact_mgr.a_apl_charact_val_ver_meas_val,m_perehods[i].t_per);
								m_api->m_data.PutAttr(ext_char[j],m_api->m_charact_mgr.a_apl_charact_val_ver_is_changed,true);
							}
							found_tper=true;
						}
						//////////////////////////////////////////////////////////////////////////
						else if(charact==m_diametr_char) 
						{
							m_api->m_data.GetAttr(ext_char[j],m_api->m_charact_mgr.a_apl_charact_val_ver_meas_val,val);
							if(val!=m_perehods[i].diametr) 
							{
								m_api->m_data.PutAttr(ext_char[j],m_api->m_charact_mgr.a_apl_charact_val_ver_meas_val,m_perehods[i].diametr);
								m_api->m_data.PutAttr(ext_char[j],m_api->m_charact_mgr.a_apl_charact_val_ver_is_changed,true);
							}
							found_diametr=true;
						}
						else if(charact==m_dlina_char) 
						{
							m_api->m_data.GetAttr(ext_char[j],m_api->m_charact_mgr.a_apl_charact_val_ver_meas_val,val);
							if(val!=m_perehods[i].dlina) 
							{
								m_api->m_data.PutAttr(ext_char[j],m_api->m_charact_mgr.a_apl_charact_val_ver_meas_val,m_perehods[i].dlina);
								m_api->m_data.PutAttr(ext_char[j],m_api->m_charact_mgr.a_apl_charact_val_ver_is_changed,true);
							}
							found_dlina=true;
						}
						else if(charact==m_glubina_char) 
						{
							m_api->m_data.GetAttr(ext_char[j],m_api->m_charact_mgr.a_apl_charact_val_ver_meas_val,val);
							if(val!=m_perehods[i].glubina) 
							{
								m_api->m_data.PutAttr(ext_char[j],m_api->m_charact_mgr.a_apl_charact_val_ver_meas_val,m_perehods[i].glubina);
								m_api->m_data.PutAttr(ext_char[j],m_api->m_charact_mgr.a_apl_charact_val_ver_is_changed,true);
							}
							found_glubina=true;
						}
						else if(charact==m_prohodu_char) 
						{
							m_api->m_data.GetAttr(ext_char[j],m_api->m_charact_mgr.a_apl_charact_val_ver_meas_val,val);
							if(val!=m_perehods[i].prohodu) 
							{
								m_api->m_data.PutAttr(ext_char[j],m_api->m_charact_mgr.a_apl_charact_val_ver_meas_val,m_perehods[i].prohodu);
								m_api->m_data.PutAttr(ext_char[j],m_api->m_charact_mgr.a_apl_charact_val_ver_is_changed,true);
							}
							found_prohodu=true;
						}
						else if(charact==m_podacha_char) 
						{
							m_api->m_data.GetAttr(ext_char[j],m_api->m_charact_mgr.a_apl_charact_val_ver_meas_val,val);
							if(val!=m_perehods[i].podacha) 
							{
								m_api->m_data.PutAttr(ext_char[j],m_api->m_charact_mgr.a_apl_charact_val_ver_meas_val,m_perehods[i].podacha);
								m_api->m_data.PutAttr(ext_char[j],m_api->m_charact_mgr.a_apl_charact_val_ver_is_changed,true);
							}
							found_podacha=true;
						}
						else if(charact==m_shpindel_char) 
						{
							m_api->m_data.GetAttr(ext_char[j],m_api->m_charact_mgr.a_apl_charact_val_ver_meas_val,val);
							if(val!=m_perehods[i].shpindel) 
							{
								m_api->m_data.PutAttr(ext_char[j],m_api->m_charact_mgr.a_apl_charact_val_ver_meas_val,m_perehods[i].shpindel);
								m_api->m_data.PutAttr(ext_char[j],m_api->m_charact_mgr.a_apl_charact_val_ver_is_changed,true);
							}
							found_shpindel=true;
						}
						else if(charact==m_skorost_char) 
						{
							m_api->m_data.GetAttr(ext_char[j],m_api->m_charact_mgr.a_apl_charact_val_ver_meas_val,val);
							if(val!=m_perehods[i].skorost) 
							{
								m_api->m_data.PutAttr(ext_char[j],m_api->m_charact_mgr.a_apl_charact_val_ver_meas_val,m_perehods[i].skorost);
								m_api->m_data.PutAttr(ext_char[j],m_api->m_charact_mgr.a_apl_charact_val_ver_is_changed,true);
							}
							found_skorost=true;
						}
						else if(charact==m_obiem_char) 
						{
							m_api->m_data.GetAttr(ext_char[j],m_api->m_charact_mgr.a_apl_charact_val_ver_descr_val,s_val);
							if(s_val!=m_perehods[i].obiem) 
							{
								m_api->m_data.PutAttr(ext_char[j],m_api->m_charact_mgr.a_apl_charact_val_ver_descr_val,m_perehods[i].obiem);
								m_api->m_data.PutAttr(ext_char[j],m_api->m_charact_mgr.a_apl_charact_val_ver_is_changed,true);
							}
							found_obiem=true;
						}
						else if(charact==m_pi_char) 
						{
							m_api->m_data.GetAttr(ext_char[j],m_api->m_charact_mgr.a_apl_charact_val_ver_descr_val,s_val);
							if(s_val!=m_perehods[i].pi) 
							{
								m_api->m_data.PutAttr(ext_char[j],m_api->m_charact_mgr.a_apl_charact_val_ver_descr_val,m_perehods[i].pi);
								m_api->m_data.PutAttr(ext_char[j],m_api->m_charact_mgr.a_apl_charact_val_ver_is_changed,true);
							}
							found_pi=true;
						}
						else if(charact==m_totv_char) 
						{
							m_api->m_data.GetAttr(ext_char[j],m_api->m_charact_mgr.a_apl_charact_val_ver_meas_val,val);
							if(val!=m_perehods[i].totv) 
							{
								m_api->m_data.PutAttr(ext_char[j],m_api->m_charact_mgr.a_apl_charact_val_ver_meas_val,m_perehods[i].totv);
								m_api->m_data.PutAttr(ext_char[j],m_api->m_charact_mgr.a_apl_charact_val_ver_is_changed,true);
							}
							found_totv=true;
						}
					}

					if(!found_tper)
					{
						if(m_perehods[i].t_per!=0) 
						{
							CaplInstance *new_val=m_api->m_charact_mgr.CreateMeasuredCharacteristic(m_perehods[i].perehod,m_tper_char, 0, m_perehods[i].t_per,0,0);
							if(new_val) 
							{
								CaplInstance *act_ver=0;
								m_api->m_data.GetAttr(new_val,m_api->m_charact_mgr.a_apl_charact_val_act_ver,act_ver);
								if(act_ver) m_api->m_data.PutAttr(new_val,m_api->m_charact_mgr.a_apl_charact_val_lock_ver,act_ver);
							}
						}
					}
					//////////////////////////////////////////////////////////////////////////
					if(!found_diametr)
					{
						if(m_perehods[i].diametr!=0) 
						{
							CaplInstance *new_val=m_api->m_charact_mgr.CreateMeasuredCharacteristic(m_perehods[i].perehod, m_diametr_char, 0, m_perehods[i].diametr, 0, 0);
							if(new_val) 
							{
								CaplInstance *act_ver=0;
								m_api->m_data.GetAttr(new_val,m_api->m_charact_mgr.a_apl_charact_val_act_ver,act_ver);
								if(act_ver) m_api->m_data.PutAttr(new_val,m_api->m_charact_mgr.a_apl_charact_val_lock_ver,act_ver);
							}
						}
					}
					if(!found_dlina)
					{
						if(m_perehods[i].dlina!=0) 
						{
							CaplInstance *new_val=m_api->m_charact_mgr.CreateMeasuredCharacteristic(m_perehods[i].perehod, m_dlina_char, 0, m_perehods[i].dlina, 0, 0);
							if(new_val) 
							{
								CaplInstance *act_ver=0;
								m_api->m_data.GetAttr(new_val,m_api->m_charact_mgr.a_apl_charact_val_act_ver,act_ver);
								if(act_ver) m_api->m_data.PutAttr(new_val,m_api->m_charact_mgr.a_apl_charact_val_lock_ver,act_ver);
							}
						}
					}
					if(!found_glubina)
					{
						if(m_perehods[i].glubina!=0) 
						{
							CaplInstance *new_val=m_api->m_charact_mgr.CreateMeasuredCharacteristic(m_perehods[i].perehod, m_glubina_char, 0, m_perehods[i].glubina, 0, 0);
							if(new_val) 
							{
								CaplInstance *act_ver=0;
								m_api->m_data.GetAttr(new_val,m_api->m_charact_mgr.a_apl_charact_val_act_ver,act_ver);
								if(act_ver) m_api->m_data.PutAttr(new_val,m_api->m_charact_mgr.a_apl_charact_val_lock_ver,act_ver);
							}
						}
					}
					if(!found_prohodu)
					{
						if(m_perehods[i].prohodu!=0) 
						{
							CaplInstance *new_val=m_api->m_charact_mgr.CreateMeasuredCharacteristic(m_perehods[i].perehod, m_prohodu_char, 0, m_perehods[i].prohodu, 0, 0);
							if(new_val) 
							{
								CaplInstance *act_ver=0;
								m_api->m_data.GetAttr(new_val,m_api->m_charact_mgr.a_apl_charact_val_act_ver,act_ver);
								if(act_ver) m_api->m_data.PutAttr(new_val,m_api->m_charact_mgr.a_apl_charact_val_lock_ver,act_ver);
							}
						}
					}
					if(!found_podacha)
					{
						if(m_perehods[i].podacha!=0) 
						{
							CaplInstance *new_val=m_api->m_charact_mgr.CreateMeasuredCharacteristic(m_perehods[i].perehod, m_podacha_char, 0, m_perehods[i].podacha, 0, 0);
							if(new_val) 
							{
								CaplInstance *act_ver=0;
								m_api->m_data.GetAttr(new_val,m_api->m_charact_mgr.a_apl_charact_val_act_ver,act_ver);
								if(act_ver) m_api->m_data.PutAttr(new_val,m_api->m_charact_mgr.a_apl_charact_val_lock_ver,act_ver);
							}
						}
					}
					if(!found_shpindel)
					{
						if(m_perehods[i].shpindel!=0) 
						{
							CaplInstance *new_val=m_api->m_charact_mgr.CreateMeasuredCharacteristic(m_perehods[i].perehod, m_shpindel_char, 0, m_perehods[i].shpindel, 0, 0);
							if(new_val) 
							{
								CaplInstance *act_ver=0;
								m_api->m_data.GetAttr(new_val,m_api->m_charact_mgr.a_apl_charact_val_act_ver,act_ver);
								if(act_ver) m_api->m_data.PutAttr(new_val,m_api->m_charact_mgr.a_apl_charact_val_lock_ver,act_ver);
							}
						}
					}
					if(!found_skorost)
					{
						if(m_perehods[i].skorost!=0) 
						{
							CaplInstance *new_val=m_api->m_charact_mgr.CreateMeasuredCharacteristic(m_perehods[i].perehod, m_skorost_char, 0, m_perehods[i].skorost, 0, 0);
							if(new_val) 
							{
								CaplInstance *act_ver=0;
								m_api->m_data.GetAttr(new_val,m_api->m_charact_mgr.a_apl_charact_val_act_ver,act_ver);
								if(act_ver) m_api->m_data.PutAttr(new_val,m_api->m_charact_mgr.a_apl_charact_val_lock_ver,act_ver);
							}
						}
					}
					if(!found_obiem)
					{
						if(false == m_perehods[i].obiem.IsEmpty()) 
						{
							CaplInstance *new_val=m_api->m_charact_mgr.CreateDescriptiveCharacteristic(m_perehods[i].perehod, m_obiem_char, 0, m_perehods[i].obiem);
							if(new_val) 
							{
								CaplInstance *act_ver=0;
								m_api->m_data.GetAttr(new_val,m_api->m_charact_mgr.a_apl_charact_val_act_ver,act_ver);
								if(act_ver) m_api->m_data.PutAttr(new_val,m_api->m_charact_mgr.a_apl_charact_val_lock_ver,act_ver);
							}
						}
					}
					if(!found_pi)
					{
						if(false == m_perehods[i].pi.IsEmpty()) 
						{
							CaplInstance *new_val=m_api->m_charact_mgr.CreateDescriptiveCharacteristic(m_perehods[i].perehod, m_pi_char, 0, m_perehods[i].pi);
							if(new_val) 
							{
								CaplInstance *act_ver=0;
								m_api->m_data.GetAttr(new_val,m_api->m_charact_mgr.a_apl_charact_val_act_ver,act_ver);
								if(act_ver) m_api->m_data.PutAttr(new_val,m_api->m_charact_mgr.a_apl_charact_val_lock_ver,act_ver);
							}
						}
					}
					if(!found_totv)
					{
						if(m_perehods[i].totv!=0) 
						{
							CaplInstance *new_val=m_api->m_charact_mgr.CreateMeasuredCharacteristic(m_perehods[i].perehod, m_totv_char, 0, m_perehods[i].totv, 0, 0);
							if(new_val) 
							{
								CaplInstance *act_ver=0;
								m_api->m_data.GetAttr(new_val,m_api->m_charact_mgr.a_apl_charact_val_act_ver,act_ver);
								if(act_ver) m_api->m_data.PutAttr(new_val,m_api->m_charact_mgr.a_apl_charact_val_lock_ver,act_ver);
							}
						}
					}
				}
				aplExtent ext_res,ext_new_res;
				CaplInstance *res_type=0;
				CaplInstance *object=0;
				double val=0;
				m_api->m_data.GetAttr(perehod_lock,m_api->m_bp_mgr.a_bp_ver_res,ext_res);
				bool smth_changed=false;
				int res_count=0;
				CaplInstance *ed_izm;
				CString poz_instr;
				aplExtent ext_char,ext_group;
				for(int m=0;m<m_osnastka.GetSize();m++)
				{
					if(m_osnastka[m].perehod==m_perehods[i].key)
					{
						res_count++;
						bool found_res=false;
						bool need_new_res=false;
						int replace_num=-1;
						CaplInstance *char_val=0,*char_lock=0; 
						for(int l=0;l<ext_res.GetSize();l++)
						{
							if(m_osnastka[m].resource==ext_res[l])
							{
								found_res=true;
								m_api->m_data.GetAttr(ext_res[l],m_api->m_bp_mgr.a_bp_res_object,object);
								m_api->m_data.GetAttr(ext_res[l],m_api->m_bp_mgr.a_bp_res_type,res_type);
								m_api->m_data.GetAttr(ext_res[l],m_api->m_bp_mgr.a_bp_res_val,val);
								m_api->m_data.GetAttr(ext_res[l],m_api->m_bp_mgr.a_bp_res_unit,ed_izm);
								if(m_poz_instr_char)
								{
									m_api->m_charact_mgr.FindAssociatedCharacteristic(ext_res[l], ext_char,ext_group,false,false,false);
									CaplInstance *charact=0;
									poz_instr="";
									for(int f=0;f<ext_char.GetSize();f++)
									{
										m_api->m_data.GetAttr(ext_char[f],m_api->m_charact_mgr.a_apl_charact_val_charact,charact);
										if(charact==m_poz_instr_char)
										{
											char_val=ext_char[f];
											char_lock=m_api->m_charact_mgr.CheckMyLock(ext_char[f],false);
											if(char_lock) m_api->m_data.GetAttr(char_lock,m_api->m_charact_mgr.a_apl_charact_val_ver_descr_val,poz_instr);
											else m_api->m_data.GetAttr(ext_char[f],m_api->m_charact_mgr.a_apl_charact_val_descr_val,poz_instr);
											break;
										}
									}
								}
								if(m_osnastka[m].object!=object || m_osnastka[m].res_type!=res_type || m_osnastka[m].amount!=val || m_osnastka[m].ed_izm!=ed_izm)
								{
									need_new_res=true;
									replace_num=l;
								}
								if(m_osnastka[m].poz_instr!=poz_instr && m_poz_instr_char)
								{
									if(char_val)//   
									{
										if(!char_lock)
										{
											m_api->m_charact_mgr.CheckOut(char_val);
											char_lock=m_api->m_charact_mgr.CheckMyLock(char_val,false);
										}
										if(char_lock) 
										{
											m_api->m_data.PutAttr(char_lock,m_api->m_charact_mgr.a_apl_charact_val_ver_descr_val,m_osnastka[m].poz_instr);
											m_api->m_data.PutAttr(char_lock,m_api->m_charact_mgr.a_apl_charact_val_ver_is_changed,true);
										}
											
									}
									else//  
									{
										char_val=m_api->m_charact_mgr.CreateDescriptiveCharacteristic(m_osnastka[m].resource,m_poz_instr_char, 0,m_osnastka[m].poz_instr);
										if(char_val) 
										{
											CaplInstance *act_ver=0;
											m_api->m_data.GetAttr(char_val,m_api->m_charact_mgr.a_apl_charact_val_act_ver,act_ver);
											if(act_ver)
											{
												m_api->m_data.PutAttr(char_val,m_api->m_charact_mgr.a_apl_charact_val_lock_ver,act_ver);
												char_lock=act_ver;
												m_api->m_data.PutAttr(act_ver,m_api->m_charact_mgr.a_apl_charact_val_ver_is_changed,true);
											}
										}	
									}
								}
								if(check_in_chars && char_val) 
								{
									if(char_lock) 
									{
										bool is_char_changed;
										m_api->m_data.GetAttr(char_lock,m_api->m_charact_mgr.a_apl_charact_val_ver_is_changed,is_char_changed);
										if(is_char_changed) m_api->m_charact_mgr.CheckIn(char_val); 
										else m_api->m_charact_mgr.UndoCheckOut(char_val,false); 
									}
								}
								break;
							}
						}
						if(!found_res || need_new_res)
						{
							smth_changed=true;
							m_osnastka[m].resource=m_api->m_data.CreateInstance(m_api->m_bp_mgr.e_bp_res);
							if(m_osnastka[m].resource)
							{
								m_api->m_data.PutAttr(m_osnastka[m].resource,m_api->m_bp_mgr.a_bp_res_process,m_perehods[i].perehod);
								m_api->m_data.PutAttr(m_osnastka[m].resource,m_api->m_bp_mgr.a_bp_res_object,m_osnastka[m].object);
								m_api->m_data.PutAttr(m_osnastka[m].resource,m_api->m_bp_mgr.a_bp_res_type,m_osnastka[m].res_type);
								m_api->m_data.PutAttr(m_osnastka[m].resource,m_api->m_bp_mgr.a_bp_res_val,m_osnastka[m].amount);
								m_api->m_data.PutAttr(m_osnastka[m].resource,m_api->m_bp_mgr.a_bp_res_unit,m_osnastka[m].ed_izm);
							}
						}
						if(m_osnastka[m].resource) ext_new_res.Add(m_osnastka[m].resource);
					}

				}
				if(ext_res.GetSize() !=res_count) smth_changed=true;
				if(smth_changed)
				{
					m_api->m_data.PutAttr(perehod_lock,m_api->m_bp_mgr.a_bp_ver_res,ext_new_res);
				}
			}
		}
		
	}
	//    
	for(i=0;i<m_operations.GetSize();i++) 
	{
		int j;
		aplExtent ext_perehods;
		if(!m_operations[i].bp) continue;
		CaplInstance *oper_lock=m_api->m_bp_mgr.CheckMyLock(m_operations[i].bp,false);
		if(!oper_lock) continue;
		for(j=0;j<m_perehods.GetSize();j++) 
		{
			if(!m_perehods[j].perehod) continue;
			if(m_perehods[j].perehod->GetAccessmode()>aplRO) continue;
			if(m_operations[i].key==m_perehods[j].oper) ext_perehods.Add(m_perehods[j].perehod);
		}
		//   ,   ""
		aplExtent ext_old;
		m_api->m_data.GetAttr(oper_lock,m_api->m_bp_mgr.a_bp_ver_elements,ext_old);
		for(j=0;j<ext_old.GetSize();j++)
		{
			CaplInstance *type=0;
			CaplInstance *perehod_lock=m_api->m_bp_mgr.CheckMyLock(ext_old[j],false);
			if(perehod_lock) m_api->m_data.GetAttr(perehod_lock,m_api->m_bp_mgr.a_bp_ver_type,type);
			else m_api->m_data.GetAttr(ext_old[j],m_api->m_bp_mgr.a_bp_type,type);
			if(type!=m_perehod_bp_type) 
			{
				if(j<ext_perehods.GetSize()) ext_perehods.Insert(j,ext_old[j]);
				else ext_perehods.Add(ext_old[j]);
			}
		}
		m_api->m_data.PutAttr(oper_lock,m_api->m_bp_mgr.a_bp_ver_elements,ext_perehods);
	}
	//     
	CaplInstance *doc=0;
	for(i=0;i<m_operations.GetSize();i++) 
	{
		if(m_operations[i].instruk_rel)
		{
			m_api->m_data.GetAttr(m_operations[i].instruk_rel,m_api->m_doc_mgr.a_apl_doc_ref_doc,doc);
			if(doc!=m_operations[i].instruk) 
				m_api->m_data.PutAttr(m_operations[i].instruk_rel,m_api->m_doc_mgr.a_apl_doc_ref_doc,m_operations[i].instruk);
		}
		else
		{
			if(m_operations[i].instruk && m_operations[i].bp) 
			{
				m_api->m_doc_mgr.CreateAssociation(m_operations[i].bp,m_operations[i].instruk);
			}
		}
		if(m_operations[i].upr_prog_rel)
		{
			m_api->m_data.GetAttr(m_operations[i].upr_prog_rel,m_api->m_doc_mgr.a_apl_doc_ref_doc,doc);
			if(doc!=m_operations[i].upr_prog) 
				m_api->m_data.PutAttr(m_operations[i].upr_prog_rel,m_api->m_doc_mgr.a_apl_doc_ref_doc,m_operations[i].upr_prog);
		}
		else
		{
			if(m_operations[i].upr_prog && m_operations[i].bp) 
			{
				m_api->m_doc_mgr.CreateAssociation(m_operations[i].bp,m_operations[i].upr_prog);
			}
		}
	}
	for(i=0;i<m_perehods.GetSize();i++) 
	{
		if(m_perehods[i].ac_doc_rel)
		{
			m_api->m_data.GetAttr(m_perehods[i].ac_doc_rel,m_api->m_doc_mgr.a_apl_doc_ref_doc,doc);
			if(doc!=m_perehods[i].ac_doc) m_api->m_data.PutAttr(m_perehods[i].ac_doc_rel,m_api->m_doc_mgr.a_apl_doc_ref_doc,m_perehods[i].ac_doc);
		}
		else
		{
			if(m_perehods[i].ac_doc && m_perehods[i].perehod) 
			{
				m_api->m_doc_mgr.CreateAssociation(m_perehods[i].perehod,m_perehods[i].ac_doc);
			}
		}
	}
	m_api->m_data.NET_SaveChanges();
	aplEndWaitDlg(trd);
	m_api->m_bp_mgr.m_bCheckUniqs=oldCheckUniqs;
	m_api->m_bp_mgr.m_AutoSave = old_AS;
	m_api->m_charact_mgr.m_AutoSave=old_AS_char;
	return true;
}

void CTechProcessDlg::OnOK() 
{
	// TODO: Add extra validation here
	if(!SaveChanges()) 
	{
		return;
	}
	//if(!OnCheckIn()) return;
	CaplResizableDialog::OnOK();
}

void CTechProcessDlg::OnCancel() 
{
	if(!EndEdit()) return;
	//if(m_bp_lock) OnUndoCheckOut();	
	CaplResizableDialog::OnCancel();
}

void CTechProcessDlg::OnDeleteOper() 
{
	if(m_ReadOnly) return;
	if(!m_bp_lock && !m_bModeCreate) return;
	if(m_edit_oper || m_edit_perehod || m_edit_osn) return;
	int k=m_operation_ctrl.GetNextItem(-1,LVNI_SELECTED);
	if(k<0)  return;
	
	if(AfxMessageBox("      ?",MB_YESNO)==IDNO) return;
	int i=0;
	while(i<m_perehods.GetSize())
	{
		if(m_perehods[i].oper==m_operations[k].key) 
			m_perehods.RemoveAt(i);
		else 
			i++;
	}
	m_operations.RemoveAt(k);

	UpdateOperationsCtrl();	
	SetReadOnlyItems();
	if(m_operations.GetSize())
	{
		if(k>=m_operations.GetSize()) k=m_operations.GetSize()-1;
		m_operation_ctrl.SetItemState(k,LVIS_SELECTED| LVIS_FOCUSED,-1);
		m_operation_ctrl.EnsureVisible(k,false);
	}
	else
	{
		UpdatePerehodsCtrl();
	}
	
}

void CTechProcessDlg::OnDblclkParams(NMHDR* pNMHDR, LRESULT* pResult) 
{
	*pResult = 0;
	if(m_ReadOnly) return;
	if(!m_bp_lock && !m_bModeCreate) return;
	LPNMITEMACTIVATE lpnmitem = (LPNMITEMACTIVATE) pNMHDR;
	if(lpnmitem==0) return;
	int k=lpnmitem->iItem,j=lpnmitem->iSubItem;
	if(k<0) 
	{
		if(j==1) 
		{
			if(AddOper()) k=m_operation_ctrl.GetItemCount()-1;
			else return;
		}
		else return;
	}
	
	m_edit_oper=(OperationStruct *)m_operation_ctrl.GetItemData(k);
	if(!m_edit_oper) return;
	m_last_oper=k;
	m_last_oper_col=j;

	CRect  rect( 10,0,200,30 );
	m_operation_ctrl.GetSubItemRect( k, j, LVIR_BOUNDS, rect);
	rect.top-=2;
	rect.bottom++;
	CString buf;
	CString sValue;

	if(j==1)// 
	{
		m_edit_id.SetWindowText(m_edit_oper->id);
		m_last_oper_id=m_edit_oper->id;
		m_edit_id.MoveWindow(rect);
		m_edit_id.ShowWindow(SW_SHOW);
		m_edit_id.SetFocus();
	}
	if(j==2)// 
	{
		if(!m_combo.GetCount()) 
		{
			m_edit_oper=0;
			return;
		}
		rect.bottom+=200;
		m_combo.MoveWindow(rect);
		m_combo.SelectString(-1,m_edit_oper->name);
		m_combo.ShowWindow(SW_SHOW);
	}
	else if(j==3)//
	{
		if(!m_oborud_res_type) 
		{
			m_edit_oper=0;
			return;
		}
		CaplInstance *oborud=0;
		if(m_b_select_from_classifier)
		{
			m_api->m_classifier_mgr.SelectItem(&oborud,m_ob_classif,APL_SELECT_CLASSIFIER_ITEM|APL_CLASSIFIER_EDITOR,"   ");
		}
		else
		{
			oborud=m_api->m_bp_mgr.SelectInstance(APL_MODE_SELECT_PDF|APL_MODE_SELECT_PRDINST,"   ");
		}
		if(oborud)
		{
			m_edit_oper->oborud=oborud;
			m_api->GetItemName(oborud,buf);
			m_operation_ctrl.SetItemText(m_last_oper,3,buf);
		}
		m_edit_oper=0;
	}
	else if(j==4)///
	{
		if(!m_mk_ok_char) 
		{
			m_edit_oper=0;
			return;
		}
		rect.bottom+=200;
		m_combo_char.ResetContent();
		m_combo_char.AddString("");
		m_combo_char.AddString("");
		m_combo_char.MoveWindow(rect);
		m_combo_char.SelectString(-1,m_edit_oper->mk_ok);
		m_combo_char.ShowWindow(SW_SHOW);
	}
	else if(j==5)//
	{
		if(!m_tp_char) 
		{
			m_edit_oper=0;
			return;
		}
		rect.bottom+=200;
		m_combo_char.ResetContent();
		m_combo_char.AddString("");
		m_combo_char.AddString("");
		m_combo_char.MoveWindow(rect);
		m_combo_char.SelectString(-1,m_edit_oper->tech_passport);
		m_combo_char.ShowWindow(SW_SHOW);
	}
	else if(j == 6) // 
	{
		if(!m_hardness_char)
		{
			m_edit_oper=0;
			return;
		}

		m_edit_id.SetWindowText(m_edit_oper->hardness);
		m_edit_id.MoveWindow(rect);
		m_edit_id.ShowWindow(SW_SHOW);
		m_edit_id.SetFocus();
		m_edit_id.SetSel(0, -1);
	}
	else if(j == 7) // 
	{
		if(!m_to_char)
		{
			m_edit_oper=0;
			return;
		}

		sValue.Format("%g", m_edit_oper->to);
		m_edit_id.SetWindowText(sValue);
		m_edit_id.MoveWindow(rect);
		m_edit_id.ShowWindow(SW_SHOW);
		m_edit_id.SetFocus();
		m_edit_id.SetSel(0, -1);
	}
	else if(j == 8) //  
	{
		if(!m_tv_char)
		{
			m_edit_oper=0;
			return;
		}

		sValue.Format("%g", m_edit_oper->tv);
		m_edit_id.SetWindowText(sValue);
		m_edit_id.MoveWindow(rect);
		m_edit_id.ShowWindow(SW_SHOW);
		m_edit_id.SetFocus();
		m_edit_id.SetSel(0, -1);
	}
	else if(j == 9) // 
	{
		if(!m_tpz_char)
		{
			m_edit_oper=0;
			return;
		}

		sValue.Format("%g", m_edit_oper->tpz);
		m_edit_id.SetWindowText(sValue);
		m_edit_id.MoveWindow(rect);
		m_edit_id.ShowWindow(SW_SHOW);
		m_edit_id.SetFocus();
		m_edit_id.SetSel(0, -1);
	}
	else if(j == 10) // 
	{
		if(!m_tsht_char)
		{
			m_edit_oper=0;
			return;
		}

		sValue.Format("%g", m_edit_oper->tsht);
		m_edit_id.SetWindowText(sValue);
		m_edit_id.MoveWindow(rect);
		m_edit_id.ShowWindow(SW_SHOW);
		m_edit_id.SetFocus();
		m_edit_id.SetSel(0, -1);
	}
	else if(j == 13) // 
	{
		if(!m_soj_char)
		{
			m_edit_oper=0;
			return;
		}

		CaplInstance *ciPdf = m_api->m_prd_mgr.SelectInstance(APL_MODE_SELECT_PDF, " ");
		if(ciPdf)
		{
			m_edit_oper->soj = ciPdf;
			m_api->GetItemName(ciPdf, buf);
			m_operation_ctrl.SetItemText(m_last_oper, 13, buf);
		}
	}
	else if(j==14)//
	{
		if(!m_instruk_doc_type) 
		{
			m_edit_oper=0;
			return;
		}
		CaplInstance *doc=m_api->m_doc_mgr.SelectInstance(APL_MODE_SELECT_DOC," ");
		if(doc)
		{
			CaplInstance *type=0;
			m_api->m_data.GetAttr(doc,m_api->m_doc_mgr.a_doc_kind,type);
			if(type!=m_instruk_doc_type)
			{
				AfxMessageBox("  !");
				m_edit_oper=0;
				return;
			}
			m_edit_oper->instruk=doc;
			m_api->GetItemName(doc,buf);
			m_operation_ctrl.SetItemText(m_last_oper,14,buf);
		}
		m_edit_oper=0;
	}
	else if(j==15)//.
	{
		if(!m_upr_doc_type) 
		{
			m_edit_oper=0;
			return;
		}
		CaplInstance *doc=m_api->m_doc_mgr.SelectInstance(APL_MODE_SELECT_DOC,"  ");
		if(doc)
		{
			CaplInstance *type=0;
			m_api->m_data.GetAttr(doc,m_api->m_doc_mgr.a_doc_kind,type);
			if(type!=m_upr_doc_type)
			{
				AfxMessageBox("  !");
				m_edit_oper=0;
				return;
			}
			m_edit_oper->upr_prog=doc;
			m_api->GetItemName(doc,buf);
			m_operation_ctrl.SetItemText(m_last_oper,15,buf);
		}
		m_edit_oper=0;
	}
	else if(j==16)// 
	{
		if(!m_razryad_char) 
		{
			m_edit_oper=0;
			return;
		}
		rect.bottom+=200;
		m_combo_razryad.MoveWindow(rect);
		if(m_edit_oper->razryad=="")
		{
			if(m_combo_razryad.GetCount()) 
				m_combo_razryad.SetCurSel(0);
		}
		else 
			m_combo_razryad.SelectString(-1,m_edit_oper->razryad);
		m_combo_razryad.ShowWindow(SW_SHOW);
	}
	else if(j==17)//
	{
		if(!m_ceh_char) 
		{
			m_edit_oper=0;
			return;
		}
		aplExtent rootPO;
		CaplInstance *ceh=m_api->m_appr_mgr.SelectPersonOrOrganization(APL_MODE_SELECT_ORG, rootPO," ", "  ");
		if(ceh)
		{
			m_edit_oper->ceh=ceh;
			m_api->m_data.GetAttr(ceh,m_api->m_appr_mgr.a_org_descr,buf); 
			m_operation_ctrl.SetItemText(m_last_oper,17,buf);
		}
		m_edit_oper=0;
	}
	else if(j==18)
	{
		if(!m_uch_char) 
		{
			m_edit_oper=0;
			return;
		}
		aplExtent rootPO;
		if(m_edit_oper->ceh) rootPO.Add(m_edit_oper->ceh);
		CaplInstance *uch=m_api->m_appr_mgr.SelectPersonOrOrganization(APL_MODE_SELECT_ORG, rootPO," ", "  ");
		if(uch)
		{
			m_edit_oper->uchastok=uch;
			m_api->m_data.GetAttr(uch,m_api->m_appr_mgr.a_org_descr,buf); 
			m_operation_ctrl.SetItemText(m_last_oper,18,buf);
		}
		m_edit_oper=0;
	}
	else if(j == 19) // 
	{
		if(!m_rm_char)
		{
			m_edit_oper=0;
			return;
		}

		m_edit_id.SetWindowText(m_edit_oper->rm);
		m_edit_id.MoveWindow(rect);
		m_edit_id.ShowWindow(SW_SHOW);
		m_edit_id.SetFocus();
		m_edit_id.SetSel(0, -1);
	}
}

void CTechProcessDlg::OnClickParams(NMHDR* pNMHDR, LRESULT* pResult) 
{
	*pResult = 0;
	if(!EndEdit()) return;
	UpdatePerehodsCtrl();
	SetReadOnlyItems();
}

bool CTechProcessDlg::EndEditPerehod()
{
	if(!m_edit_perehod) return true; 
	CString buf;
	m_edit.GetWindowText(buf); buf.TrimLeft(); buf.TrimRight();
	if(m_last_perehod_col==1)
	{
		if(buf=="")	{AfxMessageBox("    !"); m_edit.SetFocus(); return false; }
		m_edit_perehod->descr=buf;
		m_perehod_ctrl.SetItemText(m_last_perehod,1,buf);
	}
	else if(m_last_perehod_col==2)
	{
		if(!IsRealOrEmpty(buf))
		{
			AfxMessageBox("     !"); 
			m_edit.SetFocus(); 
			return false;
		}
		if(atof(buf)<0)
		{
			AfxMessageBox("      !"); 
			m_edit.SetFocus(); 
			return false;
		}
		m_edit_perehod->t_per=atof(buf);
		m_perehod_ctrl.SetItemText(m_last_perehod,2,buf);
		RecalcTOper(m_edit_perehod->oper);
	}
	else if(m_last_perehod_col == 6)
	{
		m_edit.GetWindowText(buf); buf.TrimLeft(); buf.TrimRight();
		if(atof(buf) < 0) {AfxMessageBox("    !"); m_edit.SetFocus(); return false; }

		m_edit_perehod->diametr = atof(buf);
		buf.Format("%g", m_edit_perehod->diametr);

		m_perehod_ctrl.SetItemText(m_last_perehod, 6, buf);
		m_edit.ShowWindow(SW_HIDE);
		m_edit_perehod = 0;		
	}
	else if(m_last_perehod_col == 7)
	{
		m_edit.GetWindowText(buf); buf.TrimLeft(); buf.TrimRight();
		if(atof(buf) < 0) {AfxMessageBox("    !"); m_edit.SetFocus(); return false; }

		m_edit_perehod->dlina = atof(buf);
		buf.Format("%g", m_edit_perehod->dlina);

		m_perehod_ctrl.SetItemText(m_last_perehod, 7, buf);
		m_edit.ShowWindow(SW_HIDE);
		m_edit_perehod = 0;		
	}
	else if(m_last_perehod_col == 8)
	{
		m_edit.GetWindowText(buf); buf.TrimLeft(); buf.TrimRight();
		if(atof(buf) < 0) {AfxMessageBox("    !"); m_edit.SetFocus(); return false; }

		m_edit_perehod->glubina = atof(buf);
		buf.Format("%g", m_edit_perehod->glubina);

		m_perehod_ctrl.SetItemText(m_last_perehod, 8, buf);
		m_edit.ShowWindow(SW_HIDE);
		m_edit_perehod = 0;		
	}
	else if(m_last_perehod_col == 9)
	{
		m_edit.GetWindowText(buf); buf.TrimLeft(); buf.TrimRight();
		if(atof(buf) < 0) {AfxMessageBox("    !"); m_edit.SetFocus(); return false; }

		m_edit_perehod->prohodu = atof(buf);
		buf.Format("%g", m_edit_perehod->prohodu);

		m_perehod_ctrl.SetItemText(m_last_perehod, 9, buf);
		m_edit.ShowWindow(SW_HIDE);
		m_edit_perehod = 0;		
	}
	else if(m_last_perehod_col == 10)
	{
		m_edit.GetWindowText(buf); buf.TrimLeft(); buf.TrimRight();
		if(atof(buf) < 0) {AfxMessageBox("    !"); m_edit.SetFocus(); return false; }

		m_edit_perehod->podacha = atof(buf);
		buf.Format("%g", m_edit_perehod->podacha);

		m_perehod_ctrl.SetItemText(m_last_perehod, 10, buf);
		m_edit.ShowWindow(SW_HIDE);
		m_edit_perehod = 0;		
	}
	else if(m_last_perehod_col == 11)
	{
		m_edit.GetWindowText(buf); buf.TrimLeft(); buf.TrimRight();
		if(atof(buf) < 0) {AfxMessageBox("    !"); m_edit.SetFocus(); return false; }

		m_edit_perehod->shpindel = atof(buf);
		buf.Format("%g", m_edit_perehod->shpindel);

		m_perehod_ctrl.SetItemText(m_last_perehod, 11, buf);
		m_edit.ShowWindow(SW_HIDE);
		m_edit_perehod = 0;		
	}
	else if(m_last_perehod_col == 12)
	{
		m_edit.GetWindowText(buf); buf.TrimLeft(); buf.TrimRight();
		if(atof(buf) < 0) {AfxMessageBox("    !"); m_edit.SetFocus(); return false; }

		m_edit_perehod->skorost = atof(buf);
		buf.Format("%g", m_edit_perehod->skorost);

		m_perehod_ctrl.SetItemText(m_last_perehod, 12, buf);
		m_edit.ShowWindow(SW_HIDE);
		m_edit_perehod = 0;		
	}
	else if(m_last_perehod_col == 13)
	{
		m_edit.GetWindowText(buf); buf.TrimLeft(); buf.TrimRight();
		if(atof(buf) < 0) {AfxMessageBox("    !"); m_edit.SetFocus(); return false; }

		m_edit_perehod->obiem = buf;
		m_perehod_ctrl.SetItemText(m_last_perehod, 13, m_edit_perehod->obiem);
		m_edit.ShowWindow(SW_HIDE);
		m_edit_perehod = 0;		
	}
	else if(m_last_perehod_col == 5)
	{
		m_edit.GetWindowText(buf); buf.TrimLeft(); buf.TrimRight();
		if(atof(buf) < 0) {AfxMessageBox("    !"); m_edit.SetFocus(); return false; }

		m_edit_perehod->pi = buf;
		m_perehod_ctrl.SetItemText(m_last_perehod, 5, m_edit_perehod->pi);
		m_edit.ShowWindow(SW_HIDE);
		m_edit_perehod = 0;		
	}
	else if(m_last_perehod_col == 3)
	{
		m_edit.GetWindowText(buf); buf.TrimLeft(); buf.TrimRight();
		if(atof(buf) < 0) {AfxMessageBox("    !"); m_edit.SetFocus(); return false; }

		m_edit_perehod->totv = atof(buf);
		buf.Format("%g", m_edit_perehod->totv);

		m_perehod_ctrl.SetItemText(m_last_perehod, 3, buf);
		m_edit.ShowWindow(SW_HIDE);
		m_edit_perehod = 0;		
	}

	m_edit.ShowWindow(SW_HIDE);
	m_edit_perehod=0;
	return true;
}

void CTechProcessDlg::RecalcTOper(long oper)
{
	CString buf;
	double toper=0;
	int i, per_amount=0;
	for(i=0;i<m_perehods.GetSize();i++)
	{
		if(m_perehods[i].oper==oper) 
		{
			toper+=m_perehods[i].t_per;
			per_amount++;
		}
	}
	for(i=0;i<m_operations.GetSize();i++)
	{
		if(m_operations[i].key==oper) 
		{
			m_operations[i].t_op=toper;
			if(floor(toper)==toper) buf.Format("%d",long(toper));
			else buf.Format("%.2f",toper);
			m_operation_ctrl.SetItemText(i,11,buf);
			m_operations[i].per_amount=per_amount;
			buf="";
			if(per_amount) buf.Format("%d",per_amount);
			m_operation_ctrl.SetItemText(i,12,buf);
			break;
		}
	}
}

bool CTechProcessDlg::EndEditOper()
{
	if(!m_edit_oper) return true; 
	CString buf;
	//  
	if(m_last_oper_col==1)
	{
		m_edit_id.GetWindowText(buf); buf.TrimLeft(); buf.TrimRight();
		if(buf=="")	{AfxMessageBox("    !"); m_edit_id.SetFocus(); return false; }
		for(int i=0;i<m_operations.GetSize();i++) 
		{
			if(m_operations[i].id==buf && i!=m_last_oper) {AfxMessageBox("   !"); m_edit_id.SetFocus(); return false; }
		}
		m_edit_oper->id=buf;
		m_operation_ctrl.SetItemText(m_last_oper,1,buf);
		m_edit_id.ShowWindow(SW_HIDE);
		m_edit_oper=0;
		if(m_last_oper_id!=buf) ChangeOperOrder();
	}
	else if(m_last_oper_col==6)
	{
		m_edit_id.GetWindowText(buf); buf.TrimLeft(); buf.TrimRight();
		m_edit_oper->hardness = buf;
		m_operation_ctrl.SetItemText(m_last_oper, 6, buf);
		m_edit_id.ShowWindow(SW_HIDE);
		m_edit_oper = 0;		
	}
	else if(m_last_oper_col==7)
	{
		m_edit_id.GetWindowText(buf); buf.TrimLeft(); buf.TrimRight();
		if(atof(buf) < 0) {AfxMessageBox("    !"); m_edit_id.SetFocus(); return false; }

		m_edit_oper->to = atof(buf);
		buf.Format("%g", m_edit_oper->to);

		m_operation_ctrl.SetItemText(m_last_oper, 7, buf);
		m_edit_id.ShowWindow(SW_HIDE);
		m_edit_oper = 0;		
	}
	else if(m_last_oper_col==8)
	{
		m_edit_id.GetWindowText(buf); buf.TrimLeft(); buf.TrimRight();
		if(atof(buf) < 0) {AfxMessageBox("    !"); m_edit_id.SetFocus(); return false; }

		m_edit_oper->tv = atof(buf);
		buf.Format("%g", m_edit_oper->tv);

		m_operation_ctrl.SetItemText(m_last_oper, 8, buf);
		m_edit_id.ShowWindow(SW_HIDE);
		m_edit_oper = 0;		
	}
	else if(m_last_oper_col==9)
	{
		m_edit_id.GetWindowText(buf); buf.TrimLeft(); buf.TrimRight();
		if(atof(buf) < 0) {AfxMessageBox("    !"); m_edit_id.SetFocus(); return false; }

		m_edit_oper->tpz = atof(buf);
		buf.Format("%g", m_edit_oper->tpz);

		m_operation_ctrl.SetItemText(m_last_oper, 9, buf);
		m_edit_id.ShowWindow(SW_HIDE);
		m_edit_oper = 0;		
	}
	else if(m_last_oper_col==10)
	{
		m_edit_id.GetWindowText(buf); buf.TrimLeft(); buf.TrimRight();
		if(atof(buf) < 0) {AfxMessageBox("    !"); m_edit_id.SetFocus(); return false; }

		m_edit_oper->tsht = atof(buf);
		buf.Format("%g", m_edit_oper->tsht);

		m_operation_ctrl.SetItemText(m_last_oper, 10, buf);
		m_edit_id.ShowWindow(SW_HIDE);
		m_edit_oper = 0;		
	}
	else if(m_last_oper_col==2)
	{
		m_combo.GetWindowText(buf); buf.TrimLeft(); buf.TrimRight();
		if(buf=="")	{AfxMessageBox("    !"); m_combo.SetFocus(); return false; }
		m_combo.ShowWindow(SW_HIDE);
		m_edit_oper->name=buf;
		m_operation_ctrl.SetItemText(m_last_oper,2,buf);
	}
	else if(m_last_oper_col==4)
	{
		m_combo_char.GetWindowText(buf); buf.TrimLeft(); buf.TrimRight();
		m_combo_char.ShowWindow(SW_HIDE);
		m_edit_oper->mk_ok=buf;
		m_operation_ctrl.SetItemText(m_last_oper,4,buf);
	}
	else if(m_last_oper_col==5)
	{
		m_combo_char.GetWindowText(buf); buf.TrimLeft(); buf.TrimRight();
		m_combo_char.ShowWindow(SW_HIDE);
		m_edit_oper->tech_passport=buf;
		m_operation_ctrl.SetItemText(m_last_oper,5,buf);
	}
	else if(m_last_oper_col==16)
	{
		m_combo_razryad.GetWindowText(buf); buf.TrimLeft(); buf.TrimRight();
		m_combo_razryad.ShowWindow(SW_HIDE);
		m_edit_oper->razryad=buf;
		m_operation_ctrl.SetItemText(m_last_oper,16,buf);
	}
	else if(m_last_oper_col==19)
	{
		m_edit_id.GetWindowText(buf); buf.TrimLeft(); buf.TrimRight();
		m_edit_oper->rm = buf;
		m_operation_ctrl.SetItemText(m_last_oper, 19, buf);
		m_edit_id.ShowWindow(SW_HIDE);
		m_edit_oper = 0;		
	}

	m_edit_oper=0;
	return true;
}

bool CTechProcessDlg::EndEditOsn()
{
	if(!m_edit_osn) return true; 
	CString buf;
	//  
	if(m_last_osn_col==1)
	{
		m_combo_res.GetWindowText(buf); buf.TrimLeft(); buf.TrimRight();
		int cur_sel=m_combo_res.GetCurSel();
		CaplInstance *res_type=(CaplInstance *)m_combo_res.GetItemData(cur_sel);
		m_combo_res.ShowWindow(SW_HIDE);
		m_edit_osn->res_type=res_type;
		m_osnastka_ctrl.SetItemText(m_last_osn,1,buf);
	}
	else if(m_last_osn_col==3)
	{
		m_edit_res.GetWindowText(buf); buf.TrimLeft(); buf.TrimRight();
		if(!IsRealOrEmpty(buf))
		{
			AfxMessageBox("    !"); 
			m_edit_res.SetFocus(); 
			return false;
		}
		if(atof(buf)<0)
		{
			AfxMessageBox("     !"); 
			m_edit_res.SetFocus(); 
			return false;
		}
		m_edit_osn->amount=atof(buf);
		m_osnastka_ctrl.SetItemText(m_last_osn,3,buf);
		m_edit_res.ShowWindow(SW_HIDE);
	}
	else if(m_last_osn_col==4)
	{
		m_combo_unit.GetWindowText(buf); buf.TrimLeft(); buf.TrimRight();
		int cur_sel=m_combo_unit.GetCurSel();
		CaplInstance *ed_izm=(CaplInstance *)m_combo_unit.GetItemData(cur_sel);
		m_combo_unit.ShowWindow(SW_HIDE);
		m_edit_osn->ed_izm=ed_izm;
		m_osnastka_ctrl.SetItemText(m_last_osn,4,buf);
	}
	else if(m_last_osn_col==5)
	{
		m_edit_res.GetWindowText(buf); buf.TrimLeft(); buf.TrimRight();
		m_edit_osn->poz_instr=buf;
		m_osnastka_ctrl.SetItemText(m_last_osn,5,buf);
		m_edit_res.ShowWindow(SW_HIDE);
	}
	m_edit_osn=0;
	return true;
}



void CTechProcessDlg::OnLButtonDown(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	if(!m_edit_oper && !m_edit_perehod) return;
	EndEditOper();
	EndEditPerehod();
	CaplResizableDialog::OnLButtonDown(nFlags, point);
}

void CTechProcessDlg::GetOperNames()
{
	CStdioFile oper_names;
	CString program_path=AfxGetApp()->m_pszHelpFilePath;
	int i=program_path.ReverseFind('\\');
	if(i)
		program_path=program_path.Left(i+1);
	if(!oper_names.Open(program_path+"klass_op.txt",CFile::modeRead))
	{
		AfxMessageBox("    'klass_op.txt'   !");
		return;
	}
	m_combo.ResetContent();
	CString buf;
	while(oper_names.ReadString(buf))
	{
		buf.TrimLeft(); buf.TrimRight();
		m_combo.AddString(buf);
	}
}

bool CTechProcessDlg::AddOper()
{
	if(m_ReadOnly) return false;
	if(!m_bp_lock && !m_bModeCreate) return false;
	if(!EndEdit()) return false;
	//if(!m_combo.GetCount()) return false;
	//   
	CString oper_id="000";
	int oper_num=0;
	int last_oper=m_operations.GetSize()-1;
	if(last_oper>=0)
	{
		oper_num=atoi(m_operations[last_oper].id);
		oper_num+=5;
		oper_id.Format("%d",oper_num);
		if(oper_num<10) oper_id="00"+oper_id;
		else if(oper_num<100) oper_id="0"+oper_id;
	}
	OperationStruct new_elem;
	new_elem.key=m_oper_next_key;
	new_elem.id=oper_id;
	if(m_mk_ok_char) new_elem.mk_ok="";
	if(m_tp_char) new_elem.tech_passport="";
	int new_per_num=m_operations.Add(new_elem);
	m_oper_next_key++;
	UpdateOperationsCtrl();
	if(m_operation_ctrl.GetItemCount())
	{
		m_operation_ctrl.SetItemState(m_operation_ctrl.GetItemCount()-1,LVIS_SELECTED| LVIS_FOCUSED,-1);
		m_operation_ctrl.EnsureVisible(m_operation_ctrl.GetItemCount()-1,false);

		m_edit_oper=&m_operations[new_per_num];
		m_last_oper=m_operation_ctrl.GetItemCount()-1;
		m_last_oper_col=1;

		CRect  rect( 10,0,200,30 );
		m_operation_ctrl.GetSubItemRect( m_last_oper, 1, LVIR_BOUNDS, rect);

		rect.top-=2;
		rect.bottom++;
		//rect.bottom+=200;
		//m_combo.MoveWindow(rect);
		//if(m_combo.GetCount()) m_combo.SetCurSel(0);
		//m_combo.ShowWindow(SW_SHOW);
		m_edit_id.SetWindowText(m_edit_oper->id);
		m_edit_id.MoveWindow(rect);
		m_edit_id.ShowWindow(SW_SHOW);
		m_delete_oper_btn.EnableWindow(true);
		if(m_operation_ctrl.GetItemCount()>1)
		{
			m_el_top_btn.ShowWindow(SW_SHOW);
			m_el_bottom_btn.ShowWindow(SW_SHOW);
		}
		//m_combo.SetFocus();
		m_edit_id.SetFocus();
	}
	return true;
}

void CTechProcessDlg::OnAddOper() 
{
	AddOper();
}

PerehodStruct::PerehodStruct()
{
	key=0;
	oper=0;
	perehod=0;
	descr="";
	t_per=0;
	osn_amount=0;
	instr_amount=0;
	ac_doc=0;
	ac_doc_rel=0;

	diametr=0;
	dlina=0;
	glubina=0;
	prohodu=0;
	podacha=0;
	shpindel=0;
	skorost=0;
	obiem="";
	pi="";
	totv=0;
}

void CTechProcessDlg::OnItemchangedOperations(NMHDR* pNMHDR, LRESULT* pResult) 
{
	*pResult = 0;
	NM_LISTVIEW* pNMListView = (NM_LISTVIEW*)pNMHDR;
	// TODO: Add your control notification handler code here
	if(m_edit_perehod) return;
	if(m_edit_oper) return;
	if(m_edit_osn) return;
	UpdatePerehodsCtrl();
	SetReadOnlyItems();
}

void CTechProcessDlg::ShowPerehodEditBoxDouble(CaplInstance *ciCharact, double &dValue, const CRect rect)
{
	if(!ciCharact)
	{
		m_edit_perehod=0;
		return;
	}

	CString str;
	str.Format("%g", dValue);

	m_edit.SetWindowText(str);
	m_edit.MoveWindow(rect);

	m_edit.ShowWindow(SW_SHOW);
	m_edit.SetFocus();
	m_edit.SetSel(0, -1);
}

void CTechProcessDlg::OnDblclkPerehods(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: Add your control notification handler code here
	
	*pResult = 0;
	if(m_ReadOnly) return;
	if(!m_bp_lock && !m_bModeCreate) return;
	LPNMITEMACTIVATE lpnmitem = (LPNMITEMACTIVATE) pNMHDR;
	if(lpnmitem==0) return;
	int k=lpnmitem->iItem,j=lpnmitem->iSubItem;
	if(k<0) 
	{
		if(j==1) 
		{
			if(AddPerehod()) k=m_perehod_ctrl.GetItemCount()-1;
			else return;
		}
		else return;
	}
	
	m_edit_perehod=(PerehodStruct *)m_perehod_ctrl.GetItemData(k);
	if(!m_edit_perehod) return;
	m_last_perehod=k;
	m_last_perehod_col=j;

	CRect  rect( 10,0,200,30 );
	m_perehod_ctrl.GetSubItemRect( k, j, LVIR_BOUNDS, rect);
	rect.top-=2;
	rect.bottom++;
	CString buf;

	if(j==1)// 
	{
		m_edit.SetWindowText(m_edit_perehod->descr);
		m_edit.MoveWindow(rect);
		m_edit.ShowWindow(SW_SHOW);
		m_edit.SetFocus();
	}
	else if(j==2)//t 
	{
		if(!m_tper_char)
		{
			m_edit_perehod=0;
			return;
		}
		if(floor(m_edit_perehod->t_per)==m_edit_perehod->t_per) buf.Format("%d",long(m_edit_perehod->t_per));
		else buf.Format("%.2f",m_edit_perehod->t_per);
		m_edit.SetWindowText(buf);
		m_edit.MoveWindow(rect);
		m_edit.ShowWindow(SW_SHOW);
		m_edit.SetFocus();
	}
	else if(j == 6)
	{
		ShowPerehodEditBoxDouble(m_diametr_char, m_edit_perehod->diametr, rect);		
	}
	else if(j == 7)
	{
		ShowPerehodEditBoxDouble(m_dlina_char, m_edit_perehod->dlina, rect);				
	}

	else if(j == 8)
	{
		ShowPerehodEditBoxDouble(m_glubina_char, m_edit_perehod->glubina, rect);
	}
	else if(j == 9)
	{
		ShowPerehodEditBoxDouble(m_prohodu_char, m_edit_perehod->prohodu, rect);
	}
	else if(j == 10)
	{
		ShowPerehodEditBoxDouble(m_podacha_char, m_edit_perehod->podacha, rect);
	}
	else if(j == 11)
	{
		ShowPerehodEditBoxDouble(m_shpindel_char, m_edit_perehod->shpindel, rect);
	}
	else if(j == 12)
	{
		ShowPerehodEditBoxDouble(m_skorost_char, m_edit_perehod->skorost, rect);
	}
	else if(j == 13)
	{
		if(!m_obiem_char)
		{
			m_edit_perehod=0;
			return;
		}
		
		m_edit.SetWindowText(m_edit_perehod->obiem);
		m_edit.MoveWindow(rect);
		m_edit.ShowWindow(SW_SHOW);
		m_edit.SetFocus();
		m_edit.SetSel(0, -1);
	}
	else if(j == 5)
	{
		if(!m_pi_char)
		{
			m_edit_perehod=0;
			return;
		}

		m_edit.SetWindowText(m_edit_perehod->pi);
		m_edit.MoveWindow(rect);
		m_edit.ShowWindow(SW_SHOW);
		m_edit.SetFocus();
		m_edit.SetSel(0, -1);
	}
	else if(j == 3)
	{
		ShowPerehodEditBoxDouble(m_totv_char, m_edit_perehod->totv, rect);
	}
	else if(j==14)// 
	{
		CaplInstance *doc=m_api->m_doc_mgr.SelectInstance(APL_MODE_SELECT_DOC," ");
		if(doc)
		{
			m_edit_perehod->ac_doc=doc;
			m_api->GetItemName(doc,buf);
			m_perehod_ctrl.SetItemText(m_last_perehod,4,buf);
		}
		m_edit_perehod=0;
	}	
}

bool CTechProcessDlg::EndEdit()
{
	if(m_edit_oper) if(!EndEditOper()) return false;
	if(m_edit_perehod) if(!EndEditPerehod()) return false;
	if(m_edit_osn) if(!EndEditOsn()) return false;
	return true;
}

void CTechProcessDlg::OnClickPerehods(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: Add your control notification handler code here
	*pResult = 0;
	if(!EndEdit()) return;
	UpdateOsnastkaCtrl();
	SetReadOnlyItems();
}

bool CTechProcessDlg::AddPerehod() 
{
	if(m_ReadOnly) return false;
	if(!m_bp_lock && !m_bModeCreate) return false;
	if(!EndEdit()) return false;
	int num=m_operation_ctrl.GetNextItem(-1,LVNI_SELECTED);
	if(num<0) return false;
	OperationStruct *sel_oper=(OperationStruct *)m_operation_ctrl.GetItemData(num);
	if(!sel_oper) return false;

	PerehodStruct new_elem;
	new_elem.oper=sel_oper->key;
	new_elem.key=m_perehod_next_key;
	int new_per_num=m_perehods.Add(new_elem);
	m_perehod_next_key++;
	RecalcTOper(sel_oper->key);
	UpdatePerehodsCtrl();
	if(m_perehod_ctrl.GetItemCount())
	{
		m_perehod_ctrl.SetItemState(m_perehod_ctrl.GetItemCount()-1,LVIS_SELECTED| LVIS_FOCUSED,-1);
		m_perehod_ctrl.EnsureVisible(m_perehod_ctrl.GetItemCount()-1,false);
		m_edit_perehod=&m_perehods[new_per_num];
		m_last_perehod=m_perehod_ctrl.GetItemCount()-1;
		m_last_perehod_col=1;

		CRect  rect( 10,0,200,30 );
		m_perehod_ctrl.GetSubItemRect( m_last_perehod, 1, LVIR_BOUNDS, rect);
		rect.top-=2;
		rect.bottom++;
		m_edit.SetWindowText("");
		m_edit.MoveWindow(rect);
		m_edit.ShowWindow(SW_SHOW);
		if(m_perehod_ctrl.GetItemCount()>1)
		{
			m_el_per_top_btn.ShowWindow(SW_SHOW);
			m_el_per_bottom_btn.ShowWindow(SW_SHOW);
		}
		m_delete_perehod_btn.EnableWindow(true);
		m_edit.SetFocus();
	}
	return true;
}

void CTechProcessDlg::OnAddPerehod() 
{
	AddPerehod();
}

void CTechProcessDlg::OnDeletePerehod() 
{
	if(m_ReadOnly) return;
	if(!m_bp_lock && !m_bModeCreate) return;
	if(m_edit_oper || m_edit_perehod || m_edit_osn) return;
	int k=m_perehod_ctrl.GetNextItem(-1,LVNI_SELECTED);
	if(k<0)  return;
	PerehodStruct *sel_perehod=(PerehodStruct *)m_perehod_ctrl.GetItemData(k);
	if(!sel_perehod) return;
	long sel_oper=sel_perehod->oper;

	if(AfxMessageBox("      ?",MB_YESNO)==IDNO) return;
	for(int i=0;i<m_perehods.GetSize();i++)
	{
		if(&m_perehods[i]==sel_perehod)
		{
			m_perehods.RemoveAt(i);
			break;
		}
	}
	RecalcTOper(sel_oper);
	UpdatePerehodsCtrl();	
	SetReadOnlyItems();
	if(m_perehod_ctrl.GetItemCount())
	{
		if(k>=m_perehod_ctrl.GetItemCount()) k=m_perehod_ctrl.GetItemCount()-1;
		m_perehod_ctrl.SetItemState(k,LVIS_SELECTED| LVIS_FOCUSED,-1);
		m_perehod_ctrl.EnsureVisible(k,false);
	}
	
}

void CTechProcessDlg::OnElPerTop() 
{
	if(m_edit_oper || m_edit_perehod) return;
	int k=m_perehod_ctrl.GetNextItem(-1,LVNI_SELECTED)-1;
	if(k<0)  return;
		
	PerehodStruct *sel_perehod=(PerehodStruct *)m_perehod_ctrl.GetItemData(k);
	if(!sel_perehod) return;
	int k1=m_perehod_ctrl.GetNextItem(-1,LVNI_SELECTED);
	if(k1>m_perehod_ctrl.GetItemCount()-1) return;
	PerehodStruct *bottom_perehod=(PerehodStruct *)m_perehod_ctrl.GetItemData(k1);
	if(!bottom_perehod) return;

	PerehodStruct tmp=*sel_perehod;
	*sel_perehod=*bottom_perehod;
	*bottom_perehod=tmp;

	m_perehod_ctrl.SetItemState(k,LVIS_SELECTED,-1);
	UpdatePerehodsCtrl();
	
}

void CTechProcessDlg::OnElPerBottom() 
{
	if(m_edit_oper || m_edit_perehod) return;
	int k=m_perehod_ctrl.GetNextItem(-1,LVNI_SELECTED);
	if(k<0)  return;
	if(k>m_perehod_ctrl.GetItemCount()-2) return;
	
	PerehodStruct *sel_perehod=(PerehodStruct *)m_perehod_ctrl.GetItemData(k);
	if(!sel_perehod) return;
	int k1=m_perehod_ctrl.GetNextItem(-1,LVNI_SELECTED)+1;
	if(k1>m_perehod_ctrl.GetItemCount()-1) return;
	PerehodStruct *bottom_perehod=(PerehodStruct *)m_perehod_ctrl.GetItemData(k1);
	if(!bottom_perehod) return;

	PerehodStruct tmp=*sel_perehod;
	*sel_perehod=*bottom_perehod;
	*bottom_perehod=tmp;

	m_perehod_ctrl.SetItemState(k+1,LVIS_SELECTED,-1);
	UpdatePerehodsCtrl();
	
}


void CTechProcessDlg::OnItemchangedPerehods(NMHDR* pNMHDR, LRESULT* pResult) 
{
	*pResult = 0;
	NM_LISTVIEW* pNMListView = (NM_LISTVIEW*)pNMHDR;
	// TODO: Add your control notification handler code here
	
	if(m_edit_perehod) return;
	if(m_edit_oper) return;
	if(m_edit_osn) return;
	UpdateOsnastkaCtrl();
	SetReadOnlyItems();
}

void CTechProcessDlg::OnClickOsnastka(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: Add your control notification handler code here
	*pResult = 0;
	if(!EndEdit()) return;
}

void CTechProcessDlg::OnDblclkOsnastka(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: Add your control notification handler code here
	
	*pResult = 0;
	if(m_ReadOnly) return;
	if(!m_bp_lock && !m_bModeCreate) return;
	LPNMITEMACTIVATE lpnmitem = (LPNMITEMACTIVATE) pNMHDR;
	if(lpnmitem==0) return;
	int k=lpnmitem->iItem,j=lpnmitem->iSubItem;
	if(!m_poz_instr_char && j==5) return;
	if(k<0) 
	{
		if(j==1) 
		{
			if(AddOsn()) k=m_osnastka_ctrl.GetItemCount()-1;
			else return;
		}
		else return;
	}
	
	m_edit_osn=(OsnStruct *)m_osnastka_ctrl.GetItemData(k);
	if(!m_edit_osn) return;
	m_last_osn=k;
	m_last_osn_col=j;

	CRect  rect( 10,0,200,30 );
	m_osnastka_ctrl.GetSubItemRect( k, j, LVIR_BOUNDS, rect);
	rect.top-=2;
	rect.bottom++;
	CString buf;

	if(j==1)// 
	{
		rect.bottom+=200;
		int cur_sel=0;
		for(int i=0;i<m_combo_res.GetCount();i++)
		{
			CaplInstance *res_type=(CaplInstance *)m_combo_res.GetItemData(i);
			if(res_type==m_edit_osn->res_type) 
			{
				cur_sel=i;
				break;
			}
		}
		m_combo_res.SetCurSel(cur_sel);
		m_combo_res.MoveWindow(rect);
		m_combo_res.ShowWindow(SW_SHOW);
	}
	else if(j==2)//
	{
		CaplInstance *osn=0;
		if(m_b_select_from_classifier)
		{
			m_api->m_classifier_mgr.SelectItem(&osn,m_osn_classif,APL_SELECT_CLASSIFIER_ITEM|APL_CLASSIFIER_EDITOR,"  ");
		}
		else
		{
			osn=m_api->m_bp_mgr.SelectInstance(APL_MODE_SELECT_PDF|APL_MODE_SELECT_PRDINST,"  ");
		}
		if(osn)
		{
			m_edit_osn->object=osn;
			m_api->GetItemName(osn,buf);
			m_osnastka_ctrl.SetItemText(m_last_osn,2,buf);
		}
		m_edit_oper=0;
	}
	else if(j==3)//
	{
		if(floor(m_edit_osn->amount)==m_edit_osn->amount) buf.Format("%d",long(m_edit_osn->amount));
		else buf.Format("%.2f",m_edit_osn->amount);
		m_edit_res.SetWindowText(buf);
		m_edit_res.MoveWindow(rect);
		m_edit_res.ShowWindow(SW_SHOW);
		m_edit_res.SetFocus();
	}
	else if(j==4)//..
	{
		rect.bottom+=200;
		int cur_sel=0;
		for(int i=0;i<m_combo_unit.GetCount();i++)
		{
			CaplInstance *ed_izm=(CaplInstance *)m_combo_unit.GetItemData(i);
			if(ed_izm==m_edit_osn->ed_izm) 
			{
				cur_sel=i;
				break;
			}
		}
		m_combo_unit.SetCurSel(cur_sel);
		m_combo_unit.MoveWindow(rect);
		m_combo_unit.ShowWindow(SW_SHOW);
	}
	else if(j==5)//.
	{
		m_edit_res.SetWindowText(m_edit_osn->poz_instr);
		m_edit_res.MoveWindow(rect);
		m_edit_res.ShowWindow(SW_SHOW);
		m_edit_res.SetFocus();
	}


}

bool CTechProcessDlg::AddOsn()
{
	if(m_ReadOnly) return false;
	if(!m_bp_lock && !m_bModeCreate) return false;
	if(!EndEdit()) return false;
	int num=m_perehod_ctrl.GetNextItem(-1,LVNI_SELECTED);
	if(num<0) return false;
	PerehodStruct *sel_perehod=(PerehodStruct *)m_perehod_ctrl.GetItemData(num);
	if(!sel_perehod) return false;

	CString buf="";

	CaplInstance *osn=0;
	if(m_b_select_from_classifier)
	{
		m_api->m_classifier_mgr.SelectItem(&osn,m_osn_classif,APL_SELECT_CLASSIFIER_ITEM|APL_CLASSIFIER_EDITOR,"  ");
	}
	else
	{
		osn=m_api->m_bp_mgr.SelectInstance(APL_MODE_SELECT_PDF|APL_MODE_SELECT_PRDINST,"  ");
	}
	if(osn)
	{
		OsnStruct new_elem;
		new_elem.perehod=sel_perehod->key;
		new_elem.amount=1;
		if(m_sht_unit) new_elem.ed_izm=m_sht_unit;
		int new_osn_num=m_osnastka.Add(new_elem);
		m_osnastka[new_osn_num].object=osn;
		m_api->GetItemName(osn,buf);
		m_osnastka_ctrl.SetItemText(m_osnastka_ctrl.GetItemCount()-1,2,buf);
		sel_perehod->osn_amount++;
		UpdatePerehodsCtrl();
		UpdateOsnastkaCtrl();
		m_osnastka_ctrl.SetItemState(m_osnastka_ctrl.GetItemCount()-1,LVIS_SELECTED| LVIS_FOCUSED,-1);
		m_osnastka_ctrl.EnsureVisible(m_osnastka_ctrl.GetItemCount()-1,false);
	}

	SetReadOnlyItems();
	return true;
}

void CTechProcessDlg::OnAddOsn()
{
	AddOsn();
}

void CTechProcessDlg::OnDeleteOsn() 
{
	if(m_ReadOnly) return;
	if(!m_bp_lock && !m_bModeCreate) return;
	if(m_edit_oper || m_edit_perehod || m_edit_osn) return;
	int k=m_osnastka_ctrl.GetNextItem(-1,LVNI_SELECTED);
	if(k<0)  return;
	OsnStruct *sel_osn=(OsnStruct *)m_osnastka_ctrl.GetItemData(k);
	if(!sel_osn) return;
	int num=m_perehod_ctrl.GetNextItem(-1,LVNI_SELECTED);
	if(num<0) return;
	PerehodStruct *sel_perehod=(PerehodStruct *)m_perehod_ctrl.GetItemData(num);
	if(!sel_perehod) return;
	
	if(AfxMessageBox("      ?",MB_YESNO)==IDNO) return;
	for(int i=0;i<m_osnastka.GetSize();i++)
	{
		if(&m_osnastka[i]==sel_osn)
		{
			m_osnastka.RemoveAt(i);
			break;
		}
	}
	sel_perehod->osn_amount--;
	UpdatePerehodsCtrl();	
	SetReadOnlyItems();
	if(m_osnastka_ctrl.GetItemCount())
	{
		if(k>=m_osnastka_ctrl.GetItemCount()) k=m_osnastka_ctrl.GetItemCount()-1;
		m_osnastka_ctrl.SetItemState(k,LVIS_SELECTED| LVIS_FOCUSED,-1);
		m_osnastka_ctrl.EnsureVisible(k,false);
	}
	return;
}

void CTechProcessDlg::ChangeOperOrder()
{
	if(!m_operations.GetSize() || m_operations.GetSize()==1) return;
	int num=m_operation_ctrl.GetNextItem(-1,LVNI_SELECTED);
	OperationStruct *sel_oper=0;
	long key=-1;
	if(num>-1) sel_oper=(OperationStruct *)m_operation_ctrl.GetItemData(num);
	if(sel_oper) key=sel_oper->key;
	
	int i;
	OperationStruct tmp;
	for(i=0;i<m_operations.GetSize();i++)
	{
		CString min=m_operations[i].id;
		int min_num=i;
		for(int j=i;j<m_operations.GetSize();j++)
		{
			if(m_operations[j].id<min) 
			{
				min=m_operations[j].id;
				min_num=j;
			}
		}
		tmp=m_operations[i];
		m_operations.SetAt(i,m_operations[min_num]);
		m_operations.SetAt(min_num,tmp);
	}
	if(key>-1)
	{
		for(i=0;i<m_operations.GetSize();i++)
		{
			if(m_operations[i].key==key)
			{
				m_operation_ctrl.SetItemState(i,LVIS_SELECTED,-1);
				break;
			}
		}
	}
	UpdateOperationsCtrl();
}

void CTechProcessDlg::OnRenumber() 
{
	CString oper_id="000";
	int oper_num=0;
	for(int i=0;i<m_operations.GetSize();i++)
	{
		oper_id.Format("%d",oper_num);
		if(oper_num<10) oper_id="00"+oper_id;
		else if(oper_num<100) oper_id="0"+oper_id;
		m_operations[i].id=oper_id;
		m_operation_ctrl.SetItemText(i,1,oper_id);
		oper_num+=5;
	}
}

void CTechProcessDlg::OnUseClassifier() 
{
	if(m_use_classifier_ctrl.GetCheck()) m_b_select_from_classifier=true;
	else m_b_select_from_classifier=false;
	
}

void CTechProcessDlg::OnDestroy() 
{
	int v=0;
	if(m_b_select_from_classifier) v=1;
	AfxGetApp()->WriteProfileInt(" "," ",v);
	
	CaplResizableDialog::OnDestroy();
}

void CTechProcessDlg::OnSize( UINT nType, int cx, int cy )
{
	CaplResizableDialog::OnSize(nType, cx, cy);

	if(::IsWindow(m_operation_ctrl))
	{
		int k = m_operation_ctrl.GetHeaderCtrl()->GetItemCount();
		CRect rect;
		m_operation_ctrl.GetWindowRect(&rect);
		ScreenToClient(&rect);
		cx = rect.right - rect.left - 12;

		if(k>0)
		{
			int i;
			int dx=0;
			for(i=0;i<k;i++) dx += m_operation_ctrl.GetColumnWidth(i);

			for(i=0; i<m_operation_ctrl.GetHeaderCtrl()->GetItemCount(); i++)
			{
				int l = m_operation_ctrl.GetColumnWidth(i);
				if(l == 0) break;

				HDITEM pHeader;
				pHeader.mask = HDI_WIDTH;
				m_operation_ctrl.GetHeaderCtrl()->GetItem(i, &pHeader);
				pHeader.cxy = ((cx*l)/dx)+1;
				m_operation_ctrl.GetHeaderCtrl()->SetItem(i, &pHeader);				
			}			
		}
	}

	if(::IsWindow(m_perehod_ctrl))
	{
		int k = m_perehod_ctrl.GetHeaderCtrl()->GetItemCount();
		CRect rect;
		m_perehod_ctrl.GetWindowRect(&rect);
		ScreenToClient(&rect);
		cx = rect.right - rect.left - 12;

		if(k>0)
		{
			int i;
			int dx=0;
			for(i=0;i<k;i++) dx += m_perehod_ctrl.GetColumnWidth(i);

			for(i=0; i<m_perehod_ctrl.GetHeaderCtrl()->GetItemCount(); i++)
			{
				int l = m_perehod_ctrl.GetColumnWidth(i);
				if(l == 0) break;

				HDITEM pHeader;
				pHeader.mask = HDI_WIDTH;
				m_perehod_ctrl.GetHeaderCtrl()->GetItem(i, &pHeader);
				pHeader.cxy = ((cx*l)/dx)+1;
				m_perehod_ctrl.GetHeaderCtrl()->SetItem(i, &pHeader);				
			}			
		}
	}
}
void CTechProcessDlg::OnHdnBegintrackOperations(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMHEADER phdr = reinterpret_cast<LPNMHEADER>(pNMHDR);
	*pResult = 0;
}

void CTechProcessDlg::OnLvnColumnclickOperations(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMLISTVIEW pNMLV = reinterpret_cast<LPNMLISTVIEW>(pNMHDR);
	*pResult = 0;
}

void CTechProcessDlg::OnNMSetfocusOperations(NMHDR *pNMHDR, LRESULT *pResult)
{
	// TODO: Add your control notification handler code here
	*pResult = 0;
}

void CTechProcessDlg::OnNMSetfocusPerehods(NMHDR *pNMHDR, LRESULT *pResult)
{
	// TODO: Add your control notification handler code here
	*pResult = 0;
}
